#ifndef _AnalDefs_H_
#define _AnalDefs_H_
#include <TString.h>
#include <map>

static const int NModeType = 4;
static const TString ModeType[]={  
  "PeakInvOn","PeakInvOff","DecInvOn","DecInvOff"};

struct ltstr {
  bool operator()(const char* s1, const char* s2) const
  {return strcmp(s1, s2) < 0;}
};


typedef std::map<int, int, std::less<int> >  LtMap;
typedef std::map<const char*, LtMap, ltstr> LtApvMap;

enum apvmodenum{ ANALOGUE_BIASON=1, 
                 TRIGGERMODE_SAMPLE=2,
                 CALIBRATIONOFF=4,
                 APVPEAK=8,
                 APV40MHZ=0x10,
                 APVINVERTER=0x20,
		 APVMODEUNKNOWN=0xFF, 
		 PEAKINVON=APVPEAK|APVINVERTER,
		 PEAKINVOFF=APVPEAK,
                 DECINVON=APVINVERTER,
                 DECINVOFF=0 }; 



#endif
