#ifndef _AnalSetParser_H_
#define _AnalSetParser_H_

#include<string>

/** \class AnalSetParser
    \author V.Zhukov 
    \version 1.1 
    \date 04/2004

    
    \brief   abstract settings parser
*/

class PedestalDescriptor;
class NoiseDescriptor;
class PeakTimeDescriptor;
class GainDescriptor;
class PinholeDescriptor;
class PulseHeightDescriptor;
class PipelineDescriptor;
class BackPlaneDescriptor;
class CalAmpDescriptor; 
class FBiasDescriptor;
class IVDescriptor;
class ModFlagsDescriptor;

class AnalSetParser {
 public:
virtual int parseFile(const char* c)=0;
virtual PedestalDescriptor*    getPedestalDescriptor(std::string s)=0;
virtual NoiseDescriptor*       getNoiseDescriptor(std::string s)=0;
virtual PeakTimeDescriptor*    getPeakTimeDescriptor(std::string s)=0;
virtual GainDescriptor*        getGainDescriptor(std::string s)=0;
virtual PinholeDescriptor*     getPinholeDescriptor(std::string s)=0;
virtual PulseHeightDescriptor* getPulseHeightDescriptor(std::string s)=0;
virtual PipelineDescriptor*    getPipelineDescriptor(std::string s)=0;
virtual BackPlaneDescriptor*   getBackPlaneDescriptor(std::string s)=0;
virtual CalAmpDescriptor*      getCalAmpDescriptor(std::string s)=0; 
virtual FBiasDescriptor*       getFBiasDescriptor(std::string s)=0;
virtual IVDescriptor*          getIVDescriptor(std::string s)=0;
virtual ModFlagsDescriptor*    getModFlagsDescriptor(std::string s)=0; 
virtual std::string getFileName()=0;
virtual void setFitmod(int)=0;
 protected:
 std::string fFileName;
};
#endif
