#ifndef _BasicTextDescriptor_H__
#define _BasicTextDescriptor_H_
#include "AnalSetParser.h"
#include <iostream>
#include <fstream>
#include <string>

/** \class BasicTextDescriptor
    \author L.Neukermans ,VZ
    \version 1.1 
    \date 03/2004

    
    \brief   Descriptor: define analysis cuts from tony's macro configuration file
*/

class BasicTextDescriptor: public AnalSetParser {
 public:
BasicTextDescriptor();
~BasicTextDescriptor();
int  parseFile(const char* name);
PedestalDescriptor*    getPedestalDescriptor(std::string selname);
NoiseDescriptor*       getNoiseDescriptor(std::string selname);
PeakTimeDescriptor*    getPeakTimeDescriptor(std::string selname);
GainDescriptor*        getGainDescriptor(std::string selname);
PinholeDescriptor*     getPinholeDescriptor(std::string selname);
PulseHeightDescriptor* getPulseHeightDescriptor(std::string selname);
PipelineDescriptor*    getPipelineDescriptor(std::string selname);
BackPlaneDescriptor*   getBackPlaneDescriptor(std::string selname);
CalAmpDescriptor*      getCalAmpDescriptor(std::string selname); 
FBiasDescriptor*       getFBiasDescriptor(std::string selname);
IVDescriptor*          getIVDescriptor(std::string selname);
ModFlagsDescriptor*    getModFlagsDescriptor(std::string selname); 
 bool isgood;
 std::string getFileName(){ return fFileName;}
 private:
  std::ifstream fin;
  int init();
  int fillDescriptor();
  int fillPedestalDescriptor(); 
  int fillNoiseDescriptor();    
  int fillPeakTimeDescriptor();   
  int fillGainDescriptor();	    
  int fillPinholeDescriptor();    
  int fillPulseHeightDescriptor();
  int fillPipelineDescriptor(); 
  int fillBackPlaneDescriptor();
  int fillCalAmpDescriptor();   
  int fillFBiasDescriptor();    
  int fillIVDescriptor();       
  int fillModFlagsDescriptor(); 
  void setFitmod(int);  
  PedestalDescriptor*     fPedestalDescriptor;
  NoiseDescriptor*     	  fNoiseDescriptor;   
  PeakTimeDescriptor*     fPeakTimeDescriptor;
  GainDescriptor*         fGainDescriptor;
  PinholeDescriptor*      fPinholeDescriptor;
  PulseHeightDescriptor*  fPulseHeightDescriptor;
  PipelineDescriptor*  	  fPipelineDescriptor;  
  BackPlaneDescriptor* 	  fBackPlaneDescriptor; 
  CalAmpDescriptor*    	  fCalAmpDescriptor;    
  FBiasDescriptor*     	  fFBiasDescriptor;    
  IVDescriptor*        	  fIVDescriptor;      
  ModFlagsDescriptor*  	  fModFlagsDescriptor;  
};
#endif
