#ifndef _DefAnaHistogrammer_H_
#define _DefAnaHistogrammer_H_

#include <iostream>
#include <vector>

#include "AnalDefs.h"
#include "DefAnalyzer.h"
#include "BaseAnalyzer.h"
#include "RootReader.h"

#include "TCanvas.h"
#include "TH1F.h"
#include "TString.h"

/** 
    \class DefAnaHistogrammer
    \brief 
    <p>     DefAnaHistogrammer: provides summary histograms files for each apvmode
    
    \author L.Neukermans
    \version 1.0
    \date 04/2004
    
*/

class DefAnaHistogrammer {
 public:
  DefAnaHistogrammer(DefAnalyzer* da, BaseAnalyzer *ma);
  ~DefAnaHistogrammer(){;}
  void PrintHistogramms();
  int PlotPeakTime();
  int PlotPedestal();
  int PlotPulseHeight();
  int PlotNoise();
  int PlotGain(TString);
  int PlotPinhole();
  void SetPedBound(double min, double max);
  void SetNoiseBound(double min, double max);
  void SetPeakTimeBound(double min, double max);
  void SetGainBound(double min, double max);
  void SetXLabBound(double min, double max);
  void SetYLabBound(double min, double max);
 private:
  void init();
  TestAnalyzer* a;
  RootReader* rr;
  void DrawCutLines(float min, float max);
  void DrawChipLines(float min, float max);
  int  CalcChipAvg(TH1F* h,std::vector<double>&avg, std::vector<double>& rms);
  double pedHistMin;
  double pedHistMax;
  double noiseHistMin;
  double noiseHistMax;
  double peaktimeHistMin;
  double peaktimeHistMax;
  double gainHistMin;
  double gainHistMax;
  double xMinLab; 
  double yMinLab;
  double xMaxLab;
  double yMaxLab;
  int nChip;
  int nChanPerChip;
};
#endif
