#ifndef _DefAnalyzer_H_
#define _DefAnalyzer_H_

#include "AnalDefs.h"
/** 
 \class DefAnalyzer
\brief 
<p>     DefAnalyzer: find defects.

               
     \author V.Zhukov ,IEKP 
     \version 1.0
     \date 03/2004
     
*/

class TestAnalyzer;
class AnalSetParser;
class ModFlagsDescriptor;

class DefAnalyzer {
  
 public:
  DefAnalyzer(TestAnalyzer* anal);
  virtual  ~DefAnalyzer();
  //analyze bad channels from tests
  virtual int findUnknown(int imode, int ichan);
  virtual int findNoisy(int imode, int ichan);
  virtual int findLikePinhole(int imode, int ichan);
  virtual int findLikeOS(int imode, int ichan);
  virtual int findOS(int imode, int ichan);
  virtual int findLikeTS(int imode, int ichan);
  virtual int findTS(int imode, int ichan);
  virtual int findLikeMidOpen(int imode, int ichan);
  virtual int findLikeOpen(int imode, int ichan);
  virtual int findShort(int imode, int ichan);
  virtual int findPinhole(int imode, int ichan);
  virtual  void AnalyzeBadCh();
  // final badch map
  LtApvMap getMapBadCh() {return mbadchannels;}         
  virtual void AnalyzeSensor();
  virtual void AnalyzeErrors(); 
  virtual void saveBadChMap();
  virtual void saveBadChPed();
  virtual void saveBadChCal();
  virtual void saveBadChPin();
  virtual void resetBadChMap() {mbadchannels.clear();}
  virtual int  GradeModule();
  virtual int  GradeLTModule();
  /** \brief remove noisy channels at the edge of apv */
  virtual int RemoveNoisyChannels();
  TestAnalyzer* getTestAnalyzer() {return thetestanalyzer;}
  
 protected:
  TestAnalyzer* thetestanalyzer;
  AnalSetParser* thesets;
  LtApvMap  mbadchannels;
  const char* modtype;
  int Nbadch;
};
#endif
