#ifndef _ModAnalyzer_H_
#define _ModAnalyzer_H_

#include "BaseAnalyzer.h"
#include "AnalDefs.h"

/** 
 \class ModAnalyzer
\brief 
<p>     ModAnalyzer: Analyze data stored in Root file
        from module test with ARC or CMS system
        check for bad objects, produce badflag.
               
     \author V.Zhukov ,IEKP 
     \version 1.0
     \date 02/2004
 
*/

class AnalSetParser;
class RootReader;

class ModAnalyzer:  
public BaseAnalyzer {
  
 public:
  ModAnalyzer(AnalSetParser* set, RootReader* r);
  virtual  ~ModAnalyzer();
  void Analyze();
   void AnalyzeAndPrint();
  const char* getModeType();
  LtApvMap getBadChannelMap();
 private:
  RootReader* thereader;
  AnalSetParser* thesettings;
  LtApvMap mbadchannels;
  int Nbadch;
  
};
#endif
