#ifndef _TextSummarizer_H_
#define _TextSummarizer_H_

#include <iostream>
#include <map>


#include "DefAnalyzer.h"
#include "BaseAnalyzer.h"
#include "RootReader.h"

#include "TString.h"

/** 
    \class TextSummarizer
    \brief 
    <p>     TextSummarizer: provides summary text files for each apvmode
    
    \author L.Neukermans
    \version 1.0
    \date 03/2004
    
*/

class TextSummarizer {
 public:
  TextSummarizer(DefAnalyzer* ta, BaseAnalyzer* mb);
  ~TextSummarizer(){;}
  void PrintSummary();
  void PrintHeader( TString modeName, ofstream& os );
  void PrintStatus( TString modeName, ofstream& os );
  void PrintDigit(ofstream &os, int chipNum, bool isFirstHalf, int powerTen);
  void PrintStat(ofstream& os, TString label, int chipNum, TString mode, bool isFirstHalf=true);
  void PrintDashes ( ofstream& os, int nDashes );
  void PrintProblems( ofstream &os, int chipNum, TString mode, bool isFirstHalf=true);
  void PrintChipSummary( ofstream &os, int chip, TString mode );
  int calcFailure( LtMap map, int chip );
  void PrintKey(ofstream &os);
  void PrintKeyBad(ofstream &os);
 private:
  void init();
  LtApvMap map;
  TestAnalyzer* a;
  RootReader* rr;
};
#endif
