#include "BackPlaneDescriptor.h"
#include <parsers/DOMParser.hpp>
#include <dom/DOM.hpp>
#include <dom/DOM_NamedNodeMap.hpp>
#include "DOMTreeErrorReporter.hpp"
#include <cstdio>
#include <TString.h>


using namespace std;

BackPlaneDescriptor::BackPlaneDescriptor(): AnalDescriptor() {
  init();
}

//
void BackPlaneDescriptor::init() {
    Name = "BackPlaneDescriptor";
    backplaneCutType = "NotDefined";
     minHeight = -999.;
     maxHeight = -999.; 
  
flagHeight_min=2;
flagHeight_max=4; 
 
  }
//
 void BackPlaneDescriptor::print() {
cout <<"[BackPlaneDescriptor::print] ------------------------------" <<endl;
cout <<"  TString backplaneCutType        = "<<backplaneCutType         <<endl;
cout <<"  float  minHeight                = "<< minHeight        <<endl; 
cout <<"  float   maxHeight               = "<< maxHeight        <<endl; 
cout<<"[BackPlaneDescriptor::print] ---------------------------- end"<< endl;
  }
//
int  BackPlaneDescriptor::ParseSettings(DOM_Node &ei)
{
 DT_NOTE(" BackPlane "); 
DOM_NamedNodeMap attributes = ei.getAttributes();
DOM_Node e = attributes.getNamedItem("backplaneCutType");
  if(! e.isNull() ) {backplaneCutType = (TString) e.getNodeValue().transcode();  }
 e = attributes.getNamedItem(" minHeight");
 if(! e.isNull() ) { minHeight =atof(e.getNodeValue().transcode());  }
 e = attributes.getNamedItem("maxHeight");
 if(! e.isNull() ) { maxHeight =atof(e.getNodeValue().transcode());  }
  return 0;
}
