#include "GainDescriptor.h"
#include <util/PlatformUtils.hpp>
#include <util/XMLString.hpp>
#include <util/XMLUniDefs.hpp>
#include <framework/XMLFormatter.hpp>
#include <util/TranscodingException.hpp>
#include <dom/DOM_DOMException.hpp>
#include <parsers/DOMParser.hpp>
#include <dom/DOM.hpp>
#include "DOMTreeErrorReporter.hpp"
#include <cstdio>
#include <TString.h>

using namespace std;

GainDescriptor::GainDescriptor(): AnalDescriptor() {
  init();
}

//
void GainDescriptor::init() {
  Name = "GainDescriptor";
    gainCutType    = "NotDefined";       
    minGainCutPk   = -999.; 
    maxGainCutPk   = -999.; 
    minOSGainCutPk = -999.;       
    maxPHGainCutPk = -999.;
    minGainCutDC   = -999.; 
    maxGainCutDC   = -999.; 
    minOSGainCutDC = -999.;       
    maxPHGainCutDC = -999.;

    flagGain_OSUnbound=2; 
    flagGain_Low=4; 
    flagGain_High=8; 
    flagGain_PH=16; 
  }
//
 void GainDescriptor::print() { 
cout <<"[GainDescriptor::print] ----------------------------------" <<std::endl;
cout <<"  TString gainCutType  = "<<gainCutType        <<std::endl;
cout <<"  float minGainCutPk   = "<<minGainCutPk       <<std::endl;  
cout <<"  float maxGainCutPk   = "<<maxGainCutPk       <<std::endl;
cout <<"  float minOSGainCutPk = "<<minOSGainCutPk     <<std::endl; 
cout <<"  float maxPHGainCutPk = "<<maxPHGainCutPk     <<std::endl; 
cout <<"  float minGainCutDC   = "<<minGainCutDC       <<std::endl;  
cout <<"  float maxGainCutDC   = "<<maxGainCutDC       <<std::endl;
cout <<"  float minOSGainCutDC = "<<minOSGainCutDC     <<std::endl; 
cout <<"  float maxPHGainCutDC = "<<maxPHGainCutDC     <<std::endl; 
cout<<"[GainDescriptor::print] -------------------------------- end"<<std::endl;
  }
//
int  GainDescriptor::ParseSettings(DOM_Node &ei)
{
 DT_NOTE(" Gain"); 

DOM_NamedNodeMap attributes = ei.getAttributes();
DOM_Node  e = attributes.getNamedItem("gainCutType");
  if(! e.isNull() ) { gainCutType= (TString) e.getNodeValue().transcode();  }
 e = attributes.getNamedItem("minGainCutPk");
 if(! e.isNull() ) { minGainCutPk=atof(e.getNodeValue().transcode());  }
 e = attributes.getNamedItem("maxGainCutPk");
 if(! e.isNull() ) { maxGainCutPk=atof(e.getNodeValue().transcode());  }
 e = attributes.getNamedItem("minOSGainCutPk");
 if(! e.isNull() ) { minOSGainCutPk=atof(e.getNodeValue().transcode());  }
 e = attributes.getNamedItem("maxPHGainCutPk");
 if(! e.isNull() ) {maxPHGainCutPk=atof(e.getNodeValue().transcode());  } 
 e = attributes.getNamedItem("minGainCutDC");
 if(! e.isNull() ) { minGainCutDC=atof(e.getNodeValue().transcode());  } 
 e = attributes.getNamedItem("maxGainCutDC");
 if(! e.isNull() ) {maxGainCutDC=atof(e.getNodeValue().transcode());  } 
 e = attributes.getNamedItem("minOSGainCutDC");
 if(! e.isNull() ) {minOSGainCutDC=atof(e.getNodeValue().transcode());  } 
 e = attributes.getNamedItem("maxPHGainCutDC");
 if(! e.isNull() ) {maxPHGainCutDC=atof(e.getNodeValue().transcode());  } 
  return 0;
}
