#include "IVDescriptor.h"
#include <util/PlatformUtils.hpp>
#include <util/XMLString.hpp>
#include <util/XMLUniDefs.hpp>
#include <framework/XMLFormatter.hpp>
#include <util/TranscodingException.hpp>
#include <dom/DOM_DOMException.hpp>
#include <parsers/DOMParser.hpp>
#include <dom/DOM.hpp>
#include "DOMTreeErrorReporter.hpp"
#include <cstdio>
#include <TString.h>

using namespace std;

IVDescriptor::IVDescriptor(): AnalDescriptor() {
  init();
}

//
void IVDescriptor::init() {
    Name = "IVDescriptor";
    IVCutType  = "NotDefined";       
  Vtest1= -999.;
  Vtest2= -999.;
  Vtest3= -999.;
  Imax1= -999.;
  Imax2= -999.;
  Imax3= -999.;
 flagImax1=2;  
 flagImax2=4; 
 flagImax3=8; 

  }
//
void IVDescriptor::print() {
cout <<"[IVDescriptor::print] ------------------------------" <<endl;
cout <<"  TString  IVCutType        = "<<IVCutType        <<endl;
cout <<"  float  Vtest1        = "  <<   Vtest1        <<endl; 
cout <<"  float  Vtest2        = "  <<   Vtest2          <<endl; 
cout <<"  float  Vtest3        = "  <<   Vtest3         <<endl;  
cout <<"  float  Imax1        = "  <<   Imax1        <<endl; 
cout <<"  float  Imax2        = "  <<   Imax2          <<endl; 
cout <<"  float  Imax3        = "  <<   Imax3         <<endl;  
cout<<"[IVDescriptor::print] ---------------------------- end"<<endl;
  }
//
int  IVDescriptor::ParseSettings(DOM_Node &ei)
{
 DT_NOTE(" IV "); 
DOM_NamedNodeMap attributes = ei.getAttributes();
DOM_Node  e = attributes.getNamedItem("IVCutType");
  if(! e.isNull() ) { IVCutType= (TString) e.getNodeValue().transcode();  }
 e = attributes.getNamedItem(" Vtest1");
 if(! e.isNull() ) {  Vtest1=atof(e.getNodeValue().transcode());  }
 e = attributes.getNamedItem(" Vtest2");
 if(! e.isNull() ) {  Vtest2=atof(e.getNodeValue().transcode());  }
 e = attributes.getNamedItem(" Vtest3");
 if(! e.isNull() ) {  Vtest3=atof(e.getNodeValue().transcode());  }
 e = attributes.getNamedItem(" Imax1");
 if(! e.isNull() ) {  Imax1=atof(e.getNodeValue().transcode());  }
 e = attributes.getNamedItem(" Imax2");
 if(! e.isNull() ) {  Imax2=atof(e.getNodeValue().transcode());  }
 e = attributes.getNamedItem(" Imax3");
 if(! e.isNull() ) {  Imax3=atof(e.getNodeValue().transcode());  }

  return 0;
}
