#include "NoiseDescriptor.h"
#include <parsers/DOMParser.hpp>
#include <dom/DOM.hpp>
#include <dom/DOM_NamedNodeMap.hpp>
#include "DOMTreeErrorReporter.hpp"
#include <cstdio>
#include <TString.h>

using namespace std;

NoiseDescriptor::NoiseDescriptor(): AnalDescriptor() {
  init();
}

//
 void NoiseDescriptor::init() {
    Name = "NoiseDescriptor";
    noiseCutType = "NotDefined";       
    minOneSensNoiseCutPk = -999.; 
    minTwoSensNoiseCutPk = -999.; 
    minNoiseCutPk        = -999.;       
    maxNoiseCutPk        = -999.;
    minOneSensNoiseCutDC = -999.; 
    minTwoSensNoiseCutDC = -999.; 
    minNoiseCutDC        = -999.;       
    maxNoiseCutDC        = -999.;

    flagNoise_Low          = 2; 
    flagNoise_TSUnbound    = 4; 
    flagNoise_OSUnbound    = 8; 
    flagNoise_High         = 16; 
 }

void  NoiseDescriptor::print() {
  cout <<"[NoiseDescriptor::print] ---------------------------------" <<endl,
cout <<"  TString noiseCutType        = "<<noiseCutType         <<endl;
cout <<"  float minOneSensNoiseCutPk  = "<<minOneSensNoiseCutPk <<endl; 
 cout <<"  float minTwoSensNoiseCutPk = "<<minTwoSensNoiseCutPk <<endl; 
cout <<"  float minNoiseCutPk         = "<<minNoiseCutPk         <<endl;  
cout <<"  float maxNoiseCutPk         = "<<maxNoiseCutPk         <<endl;
 cout <<"  float minOneSensNoiseCutDC = "<<minOneSensNoiseCutDC  <<endl; 
cout <<"  float minTwoSensNoiseCutDC  = "<<minTwoSensNoiseCutDC  <<endl; 
cout <<"  float minNoiseCutDC         = "<<minNoiseCutDC         <<endl;  
cout <<"  float maxNoiseCutDC         = "<<maxNoiseCutDC         <<endl;
cout<<"[NoiseDescriptor::print] ------------------------------- end"<<endl;
  }
//
 
//
int  NoiseDescriptor::ParseSettings(DOM_Node &ei)
{
 DT_NOTE(" Noise "); 

DOM_NamedNodeMap attributes = ei.getAttributes();
DOM_Node  e = attributes.getNamedItem("noiseCutType");
  if(! e.isNull() ) { noiseCutType=e.getNodeValue().transcode();  }
  e = attributes.getNamedItem("minOneSensNoiseCutPk");
  if(! e.isNull() ) { minOneSensNoiseCutPk=atof(e.getNodeValue().transcode());  }
  e = attributes.getNamedItem("minTwoSensNoiseCutPk");
  if(! e.isNull() ) { minTwoSensNoiseCutPk=atof(e.getNodeValue().transcode());  }
  e = attributes.getNamedItem("minNoiseCutPk");
  if(! e.isNull() ) { minNoiseCutPk=atof(e.getNodeValue().transcode());  }
  e = attributes.getNamedItem("maxNoiseCutPk");
  if(! e.isNull() ) { maxNoiseCutPk=atof(e.getNodeValue().transcode());  }
  e = attributes.getNamedItem("minOneSensNoiseCutDC");
  if(! e.isNull() ) { minOneSensNoiseCutDC=atof(e.getNodeValue().transcode());  }
  e = attributes.getNamedItem("minTwoSensNoiseCutDC");
  if(! e.isNull() ) { minTwoSensNoiseCutDC=atof(e.getNodeValue().transcode());  }
  e = attributes.getNamedItem("minNoiseCutDC");
  if(! e.isNull() ) { minNoiseCutDC=atof(e.getNodeValue().transcode());  }
  e = attributes.getNamedItem("maxNoiseCutDC");
  if(! e.isNull() ) { maxNoiseCutDC=atof(e.getNodeValue().transcode());  }
  return 0;
}
