#include "PeakTimeDescriptor.h"
#include <parsers/DOMParser.hpp>
#include <dom/DOM.hpp>
#include <dom/DOM_NamedNodeMap.hpp>
#include "DOMTreeErrorReporter.hpp"
#include <cstdio>
#include <TString.h>

using namespace std;

PeakTimeDescriptor::PeakTimeDescriptor(): AnalDescriptor() {
  init();
}

void PeakTimeDescriptor::print() {

cout <<"[PeakTimeDescriptor::print] ------------------------------" <<std::endl;
cout <<"  TString peaktimeCutType  = "<<peaktimeCutType        <<std::endl;
cout <<"  float minOSPeakTimeCutPk = "<<minOSPeakTimeCutPk     <<std::endl; 
cout <<"  float minTSPeakTimeCutPk = "<<minTSPeakTimeCutPk     <<std::endl; 
cout <<"  float minPeakTimeCutPk   = "<<minPeakTimeCutPk       <<std::endl;  
cout <<"  float maxPeakTimeCutPk   = "<<maxPeakTimeCutPk       <<std::endl;
cout <<"  float minOSPeakTimeCutDC = "<<minOSPeakTimeCutDC     <<std::endl; 
cout <<"  float minTSPeakTimeCutDC = "<<minTSPeakTimeCutDC     <<std::endl; 
cout <<"  float minPeakTimeCutDC   = "<<minPeakTimeCutDC       <<std::endl;  
cout <<"  float maxPeakTimeCutDC   = "<<maxPeakTimeCutDC       <<std::endl;
cout<<"[PeakTimeDescriptor::print] ---------------------------- end"<<std::endl;
  }

void  PeakTimeDescriptor::init() {
    Name = "PeakTimeDescriptor";
    peaktimeCutType    = "NotDefined";       
    minOSPeakTimeCutPk = -999.; 
    minTSPeakTimeCutPk = -999.; 
    minPeakTimeCutPk   = -999.;       
    maxPeakTimeCutPk   = -999.;
    minOSPeakTimeCutDC = -999.; 
    minTSPeakTimeCutDC = -999.; 
    minPeakTimeCutDC   = -999.;       
    maxPeakTimeCutDC   = -999.;

   flagPeakTime_Low       =  8; 
   flagPeakTime_TSUnbound = 16; 
   flagPeakTime_OSUnbound = 32; 
   flagPeakTime_High      = 64; 
  }


//
int  PeakTimeDescriptor::ParseSettings(DOM_Node &ei)
{
 DT_NOTE(" PeakTimeDescriptor "); 
DOM_NamedNodeMap attributes = ei.getAttributes();
DOM_Node   e = attributes.getNamedItem("peaktimeCutType");
  if(! e.isNull() ) { peaktimeCutType= (TString) e.getNodeValue().transcode();  }
 e = attributes.getNamedItem("minPeakTimeCutPk");
 if(! e.isNull() ) { minPeakTimeCutPk =atof(e.getNodeValue().transcode());  }
 e = attributes.getNamedItem("maxPeakTimeCutPk");
 if(! e.isNull() ) {  maxPeakTimeCutPk=atof(e.getNodeValue().transcode());  }
 e = attributes.getNamedItem("minOSPeakTimeCutPk");
 if(! e.isNull() ) {  minOSPeakTimeCutPk=atof(e.getNodeValue().transcode());  }
 e = attributes.getNamedItem("minPeakTimeCutDC");
 if(! e.isNull() ) {  minPeakTimeCutDC=atof(e.getNodeValue().transcode());  } 
 e = attributes.getNamedItem("minTSPeakTimeCutPk");
 if(! e.isNull() ) {  minTSPeakTimeCutPk=atof(e.getNodeValue().transcode());  } 
 e = attributes.getNamedItem("maxPeakTimeCutDC");
 if(! e.isNull() ) {  maxPeakTimeCutDC=atof(e.getNodeValue().transcode());  } 
 e = attributes.getNamedItem("minOSPeakTimeCutDC");
 if(! e.isNull() ) { minOSPeakTimeCutDC=atof(e.getNodeValue().transcode());  } 
 e = attributes.getNamedItem("minTSPeakTimeCutDC");
 if(! e.isNull() ) {  minTSPeakTimeCutDC=atof(e.getNodeValue().transcode());  } 
  return 0;
}
