#include "PedestalDescriptor.h"
#include <parsers/DOMParser.hpp>
#include <dom/DOM.hpp>
#include <dom/DOM_NamedNodeMap.hpp>
#include "DOMTreeErrorReporter.hpp"
#include <cstdio>
#include <TString.h>

using namespace std;

PedestalDescriptor::PedestalDescriptor(): AnalDescriptor() {
  init();
}

//
void PedestalDescriptor::init() {
    Name = "PedestalDescriptor";
    pedCutType  = "NotDefined";       
    minPedCutPk = -999.; 
    minPedCutPk = -999.; 
    minPedCutDC = -999.;       
    maxPedCutDC = -999.;

  flagPedestal_Low  = 32;;
  flagPedestal_High = 64; 
  }
//
 void PedestalDescriptor::print() {
cout <<"[PedestalDescriptor::print] ------------------------------" <<std::endl;
cout <<"  TString PedCutType         = "<<pedCutType         <<std::endl;
cout <<"  float minPedCutPk          = "<<minPedCutPk         <<std::endl; 
cout <<"  float maxCutPk             = "<<maxPedCutPk         <<std::endl; 
cout <<"  float minPedCutDC          = "<<minPedCutDC         <<std::endl;  
cout <<"  float maxPedCutDC          = "<<maxPedCutDC         <<std::endl;
cout<<"[PedestalDescriptor::print] ---------------------------- end"<< std::endl;
  }
//
int  PedestalDescriptor::ParseSettings(DOM_Node &ei)
{
  DT_NOTE(" Pedestal "); 
  DOM_NamedNodeMap attributes = ei.getAttributes();
  DOM_Node   e = attributes.getNamedItem("pedCutType");
  if(! e.isNull() ) { pedCutType= (TString) e.getNodeValue().transcode();  }
  e = attributes.getNamedItem("minPedCutPk");
  if(! e.isNull() ) { minPedCutPk=atof(e.getNodeValue().transcode());  }
  e = attributes.getNamedItem("maxPedCutPk");
  if(! e.isNull() ) { maxPedCutPk=atof(e.getNodeValue().transcode());  }
  e = attributes.getNamedItem("minPedCutDC");
  if(! e.isNull() ) { minPedCutDC=atof(e.getNodeValue().transcode());  }
  e = attributes.getNamedItem("maxPedCutDC");
  if(! e.isNull() ) { maxPedCutDC=atof(e.getNodeValue().transcode());  } 
  return 0;
}
