#include "PinholeDescriptor.h"
#include <parsers/DOMParser.hpp>
#include <dom/DOM.hpp>
#include <dom/DOM_NamedNodeMap.hpp>
#include "DOMTreeErrorReporter.hpp"
#include <cstdio>
#include <TString.h>

using namespace std;

PinholeDescriptor::PinholeDescriptor(): AnalDescriptor() {
  init();
}

//
void PinholeDescriptor::init() {
  Name = "PinholeDescriptor";
  pinholeCutType = "NotDefined";       
  maxLowPHCutPk  = -999.; 
  maxHighPHCutPk = -999.; 
  maxLowPHCutDC  = -999.;       
  maxHighPHCutDC = -999.;
  
  flagPinhole_Max1=2; 
  flagPinhole_Max2=4; 
}
//
 void PinholeDescriptor::print() {
cout <<"[PinholeDescriptor::print] -------------------------------" <<std::endl;
cout <<"  TString pinholeCutType     = "<<pinholeCutType      <<std::endl;
cout <<"  float maxLowPHCutPk        = "<<maxLowPHCutPk       <<std::endl;  
cout <<"  float maxHighPHCutPk       = "<<maxHighPHCutPk      <<std::endl;
cout <<"  float maxLowPHCutDC        = "<<maxLowPHCutDC       <<std::endl;  
cout <<"  float maxLowPHCutDC        = "<<maxHighPHCutDC      <<std::endl;
cout<<"[PinholeDescriptor::print] ----------------------------- end"<<std::endl;
  }
//
int  PinholeDescriptor::ParseSettings(DOM_Node &ei)
{
 DT_NOTE(" Pinhole "); 
DOM_NamedNodeMap attributes = ei.getAttributes();
DOM_Node e = attributes.getNamedItem("pinholeCutType");
  if(! e.isNull() ) { pinholeCutType= (TString) e.getNodeValue().transcode();  }
 e = attributes.getNamedItem("maxLowPHCutPk");
 if(! e.isNull() ) { maxLowPHCutPk=atof(e.getNodeValue().transcode());  }
 e = attributes.getNamedItem("maxHighPHCutPk");
 if(! e.isNull() ) { maxHighPHCutPk=atof(e.getNodeValue().transcode());  }
 e = attributes.getNamedItem("maxLowPHCutDC");
 if(! e.isNull() ) { maxLowPHCutDC=atof(e.getNodeValue().transcode());  }
 e = attributes.getNamedItem("maxHighPHCutDC");
 if(! e.isNull() ) {maxHighPHCutDC=atof(e.getNodeValue().transcode());  } 
  return 0;
}
