#include "PipelineDescriptor.h"
#include <parsers/DOMParser.hpp>
#include <dom/DOM.hpp>
#include <dom/DOM_NamedNodeMap.hpp>
#include "DOMTreeErrorReporter.hpp"
#include <cstdio>
#include <TString.h>


using namespace std;

PipelineDescriptor::PipelineDescriptor(): AnalDescriptor() {
  init();
}

//
void PipelineDescriptor::init() {
    Name = "PipelineDescriptor";
     pipelineCutType  = "NotDefined";
     minHeight = -999.;
     maxHeight = -999.; 
     
     flagHeight_min=2;
     flagHeight_max=4; 
 
  }
//
 void PipelineDescriptor::print() {
cout <<"[PipelineDescriptor::print] ------------------------------" <<std::endl;
cout <<"  TString PipelineCutType         = "<<pipelineCutType         <<std::endl;
cout <<"  float  minHeight          = "<< minHeight        <<std::endl; 
cout <<"  float   maxHeight             = "<< maxHeight        <<std::endl; 
cout<<"[PipelineDescriptor::print] ---------------------------- end"<< std::endl;
  }
//
int  PipelineDescriptor::ParseSettings(DOM_Node &ei)
{
 DT_NOTE(" Pipeline "); 
DOM_NamedNodeMap attributes = ei.getAttributes();
DOM_Node e = attributes.getNamedItem("pipelineCutType");
  if(! e.isNull() ) {pipelineCutType = (TString) e.getNodeValue().transcode();  }
 e = attributes.getNamedItem(" minHeight");
 if(! e.isNull() ) { minHeight =atof(e.getNodeValue().transcode());  }
 e = attributes.getNamedItem("maxHeight");
 if(! e.isNull() ) { maxHeight =atof(e.getNodeValue().transcode());  }
  return 0;
}
