#include "PulseHeightDescriptor.h"
#include <parsers/DOMParser.hpp>
#include <dom/DOM.hpp>
#include <dom/DOM_NamedNodeMap.hpp>
#include "DOMTreeErrorReporter.hpp"
#include <cstdio>
#include <TString.h>

#include "RecUtil.h"
using namespace std;
using namespace RecUtil;

PulseHeightDescriptor::PulseHeightDescriptor(): AnalDescriptor() {
  init();
}

void PulseHeightDescriptor::print() {
cout <<"[PulseHeightDescriptor::print] --------------------------" <<std::endl;
cout <<" TString pulseheightCutType    = "<<pulseheightCutType     <<std::endl;
cout <<" float minPulseHeightCutPk     = "<<minPulseHeightCutPk    <<std::endl;
cout <<" float maxPulseHeightCutPk     = "<<maxPulseHeightCutPk    <<std::endl;
cout <<" float minPulseHeightCutDC     = "<<minPulseHeightCutDC    <<std::endl;
cout <<" float maxPulseHeightCutDC     = "<<maxPulseHeightCutDC    <<std::endl;
cout <<" fitmode                       = "<<fitmode                <<std::endl;
cout<<"[PulseHeightDescriptor::print] ------------------------ end"<<std::endl;
  }

void  PulseHeightDescriptor::init() {
    Name = "PulseHeightDescriptor";
    pulseheightCutType = "NotDefined";       
    minPulseHeightCutPk  = -999.; 
    maxPulseHeightCutPk  = -999.; 
    minPulseHeightCutDC  = -999.;       
    maxPulseHeightCutDC  = -999.;
    fitmode=0;
    
    flagPulseHeight_Min=2; 
    flagPulseHeight_Max=4; 
  }
//
int  PulseHeightDescriptor::ParseSettings(DOM_Node &ei)
{
 DT_NOTE(" PulseHeightDescriptor "); 
DOM_NamedNodeMap attributes = ei.getAttributes();
DOM_Node e = attributes.getNamedItem("pulseheightCutType");
  if(! e.isNull() ) { pulseheightCutType= (TString) e.getNodeValue().transcode();  }
 e = attributes.getNamedItem("minPulseHeightCutPk");
 if(! e.isNull() ) { minPulseHeightCutPk=atof(e.getNodeValue().transcode());  }
 e = attributes.getNamedItem("maxPulseHeightCutPk");
 if(! e.isNull() ) {  maxPulseHeightCutPk=atof(e.getNodeValue().transcode());  }
 e = attributes.getNamedItem("minPulseHeightCutDC");
 if(! e.isNull() ) {  minPulseHeightCutDC=atof(e.getNodeValue().transcode());  }
 e = attributes.getNamedItem("maxPulseHeightCutDC");
 if(! e.isNull() ) { maxPulseHeightCutDC=atof(e.getNodeValue().transcode());  }  
 e = attributes.getNamedItem("fitmode");
 if(! e.isNull() ) { fitmode=atoi(e.getNodeValue().transcode()); }
 return 0;
}
