// ---------------------------------------------------------------------------
// TestDBWriter - generate a database file from a root file
// Input    : - rootfile 
// Output   : - database file  
// ---------------------------------------------------------------------------

#include <iostream>

#include <TROOT.h>

#include "XmlSetParser.h"
#include "BasicTextDescriptor.h"
#include "ModLtRootReader.h"
#include "ModLtAnalyzer.h"
#include "DbParser.h"
#include "PulseHeightDescriptor.h"

#include "DefaultPath.h"
#include "cmdlinedecode.h"
#include "RecUtil.h"

using namespace std;
using namespace lttest;
using namespace RecUtil;
// ---------------------------------------------------------------------------
// Configuration : change this 
static string defroot="reslt_M_30200020005000.root"; //default root file
// ---------------------------end of configuration

void usage (string prgname){
  cout <<endl<<" usage example : "<<endl;
  cout <<"\t"<<prgname<< " -rootin file_.root " <<endl;
  cout <<"options:"<<endl;
  cout <<"\t-rootin  :the rootfile  (default "<<defroot<<")"<<endl;  
}

int main(int argc, char **argv)
{
  cout<<"[TestDBWriter] ... enter"<<endl; 

  string cmdresult;
  string programname=argv[0];
  string filein=DefaultDataPath();
  filein=filein+defroot;
  cout << filein<<endl;
  if( "found"== CmdLineDecode(argc,argv,"h",cmdresult,false)){
    usage(programname);
    return 0;
  }
  if( "found"== CmdLineDecode(argc,argv,"rootin",cmdresult,true)){
    filein=cmdresult;
    if( filein[0] != '/') { filein=DefaultDataPath()+filein;  
    }
  }
  
  // initialize the root reader
  cout<<"[TestDBWriter] ... define a root reader"<<endl; 
  ModLtRootReader *rr =  new ModLtRootReader(filein.c_str());
  
  cout << "[TestDBWriter] ...  create DbParser " << endl;
  
  string xmlin=DefaultConfigPath()+"modlt2.xml";
  DbParser* db=new DbParser(xmlin.c_str());
  db->getDBLUT()->initmapCB();
  db->populate(rr); 
  db->write();
  delete db;
  
  delete rr;
  
  cout<<"[TestDBWriter] ... end"<<endl; 
  
  return 0;
}
