#include "AnalDefs.h"
#include "AnalSetParser.h"
#include "RecUtil.h"
#include "RootReader.h"
#include <iostream>
#include <TH1F.h>
#include <string>
#include <TDirectory.h>
#include "cmdlinedecode.h"
#include "DefaultPath.h"

using namespace std;
using namespace lttest;

void usage (string prgname){
  cout <<endl<<" usage example : "<<endl;
  cout <<"\t"<<prgname<< " -ltconfig lttemp.xml " <<endl;
  cout <<"options:"<<endl;
  cout <<"\t-rootin  :the rootfile  (default reslt_M_30200020015008.root)"<<endl;  
}

int main(int argc, char **argv){  
  
  TString objname("RawNoise");
  string programname=argv[0];
  string version= "1_00";
  string cmdresult;
  //set default path name 
  string filein=DefaultDataPath();
  filein=filein+"reslt_M_30200020015008.root";
  if( "found"== CmdLineDecode(argc,argv,"h",cmdresult,false)){
    usage(programname);
    std::exit(0);
  }
  if( "found"== CmdLineDecode(argc,argv,"rootin",cmdresult,true)){
    filein=cmdresult;
    if( filein[0] != '/') { filein=DefaultDataPath()+filein;  
    }
  }
  
  RootReader rr( filein.c_str());
  if( ! rr.FileFound()) { 
    cout << filein <<"  not found" <<endl; 
    return -1;
  }
  //gDirectory->ls();
  int recnr=-1;
  cout<< "rn of records "<<rr.FillRecordType()<< endl;
  if ((recnr=rr.GoToFirstRecord()) >= 0 ) {
    do {
      cout << "recnr "<<recnr;
      TNamed* rectodb= (TNamed*) rr.Find("TNcdb");
      if (rectodb) {
	cout << "TNcdb "<< rectodb->GetTitle()<<endl;
      }
    }while ( (recnr=rr.GoToNextRecord()) >= 0);
  }
  else { cout << " GoToFirstRecord returned " << recnr<<endl;}
  rr.GoToFirstRecord();
  TNamed* operatorname=(TNamed*) rr.Find("Operator_C");
  if (operatorname) {
    cout << " the operator "<< operatorname->GetTitle()<<endl;;
  }
  recnr=rr.GetLastRecord();
  cout << " current record is  "<< recnr << endl;
  if( rr.SetModeDir(RecUtil::apvmodedirname(PEAKINVOFF),recnr)) {
    TString fullobject= gDirectory->GetPath();
    fullobject+='/';
    fullobject=fullobject+objname;
    int filpossep=fullobject.First(':');
    fullobject=fullobject(filpossep+1,fullobject.Length());
    cout << "full object name =" <<fullobject.Data();
    //rr.cd();
    TH1F* th= (TH1F*) rr.Find(fullobject.Data()); 
    if (th) { 
      cout << "found "<<endl;
    }
    else {
      cout <<" not found " <<endl;
    }
    delete th;    
  }
  if( rr.SetModeDir(RecUtil::apvmodedirname(PEAKINVOFF),recnr)) { 
    TH1F* th= (TH1F*) rr.Find(objname.Data());
    if( th) {
      cout << "max for "<<th->GetName()<<"max = "<< th->GetMaximum() << endl;
      gDirectory->ls("-m");
      th->Scale(2);
      cout << "max = "<< th->GetMaximum() << endl;
      cout << "current record "<< rr.GetRecordNr("");
      cout << " current mode " << rr.GetApvMode()<<endl;
    }
  }
  if( rr.SetModeDir(RecUtil::apvmodedirname(APVMODEUNKNOWN),recnr)) {
    TH1F* th= (TH1F*) rr.Find(objname.Data());
    if( th) {
      cout << "max = "<< th->GetMaximum() << endl;
      gDirectory->ls("-m");
      th->Scale(2);
    }
    th= (TH1F*) rr.Find(objname.Data());
    if( th) {
      cout << __LINE__ << "max for "<<th->GetName()<<"  = "
	   << th->GetMaximum() << endl;
      cout << "gDirectory "<<gDirectory->GetPath();
      gDirectory->ls("-m");
    }
    else { cout << "not found "<<endl;}
    gDirectory->cd("..");
    cout << "gDirectory "<<gDirectory->GetPath();
    gDirectory->ls("-m");
    if( rr.SetRecord(2)) {
      th= (TH1F*) rr.Find(objname.Data());
      if( th) {
	cout << "max = "<< th->GetMaximum() << endl;
	 th->Scale(3);
	 cout << "gDirectory "<<gDirectory->GetPath()<<endl;;
	gDirectory->ls("-m");
	delete th;
	gDirectory->ls("-m");
      }
      th= (TH1F*) rr.Find(objname.Data());
      if( th) {
	cout << __LINE__ << "max = "<< th->GetMaximum() ;
	 th->Scale(4);
	 cout << " new max = "<< th->GetMaximum() << endl;
	cout << "gDirectory "<<gDirectory->GetPath();
	gDirectory->ls("-m");
	
      }
      //force a new object , read from file
      TH1F* th2= (TH1F*) rr.Find(objname.Data(),true,true);
      if( th2) {
	cout << __LINE__ << "max = "<< th2->GetMaximum();
	th2->Scale(5);
	cout << " new max = "<< th2->GetMaximum() << endl;
	cout << "gDirectory "<<gDirectory->GetPath();
	gDirectory->ls("-m");
	
      }
      th= (TH1F*) rr.Find(objname.Data());
      if( th) {
	cout << __LINE__ <<"max = "<< th->GetMaximum() << endl;
	if(! rr.Update(th->GetName())) {
	  cout << "Update failed"<<endl;
	}
	else {cout << "Update  ok"<<endl; }
	delete th;
      }
      delete th2;
      gDirectory->ls("-m");
      th= (TH1F*) rr.Find(objname.Data(),true,true); 
       if( th) {
	 cout << "max = "<< th->GetMaximum()<<endl;
       }
    }
    


  }
  else { 
    cout<<  "PeakInvOn rec 2 not found" << endl;
  }


  

  //  AnalSetParser *analparser = new AnalSetParser();
  return 0;
} 
