
#include "RecUtil.h"
#include "RootReader.h"
#include <iostream>
#include <TH1F.h>
#include <string>
#include <TDirectory.h>
#include "cmdlinedecode.h"
#include "DefaultPath.h"

using namespace std;
using namespace lttest;

void usage (string prgname){
  cout <<endl<<" usage example : "<<endl;
  cout <<"\t"<<prgname<< " -ltconfig lttemp.xml " <<endl;
  cout <<"options:"<<endl;
  cout <<"\t-rootin  :the rootfile  (default dummy2.root)"<<endl;  
}

int main(int argc, char **argv){  
  
  TString objname("Pedestal");
  string programname=argv[0];
  string version= "1_00";
  string cmdresult;
  //set default path name 
  string filein=DefaultDataPath();
  filein=filein+"dummy2.root";
  if( "found"== CmdLineDecode(argc,argv,"h",cmdresult,false)){
    usage(programname);
  }
  if( "found"== CmdLineDecode(argc,argv,"rootin",cmdresult,true)){
    filein=cmdresult;
    if( filein[0] != '/') { filein=DefaultDataPath()+filein;  
    }
  }
  
  RootReader rr( filein.c_str(),"RECREATE");
  if( ! rr.FileFound()) { 
    cout << filein <<"  problems with " <<endl; 
    return -1;
  }
  vector<int> v1;
  for ( int lc=0 ;lc < 20;lc++) {
    v1.push_back(lc);
  }
    
  TVector tv=RecUtil::totv(v1);
  
  cout << "buf size "<<rr.Write(0,&tv,0,"tv0")<<endl;
  for ( int lc=0 ;lc < 20;lc++) {
    v1.push_back(lc);
  }
  TVector* tv2= new TVector(RecUtil::totv(v1));
  tv2->Write("tv1");
  TObject* to=tv2;
  cout <<" tv2 " << tv2 <<endl;
  //to->Write();
  cout << "buf size "<<rr.Write(0,to,0,"tv2")<<endl;
  cout << "buf size "<<rr.Write(0,&RecUtil::totv(v1),0,"tv3")<<endl;
  gDirectory->ls();
  //  AnalSetParser *analparser = new AnalSetParser();
  TVector* v3=(TVector*)rr.Find("tv2");
  if (!v3) { cout << "v2 not found "<<endl;} 
  else { cout << "v2  found "<<endl;}
  gDirectory->ls();
  cout << v3 <<endl;
  TVector* v4=(TVector*)rr.Find("tv2");
  if (!v4) { cout << "v2 not found "<<endl;} 
  else { cout << "v2  found "<<endl;}
  gDirectory->ls();
  cout << v4 <<endl;
  cout << "buf5 size "<<rr.Write("newdir/nn/",&RecUtil::totv(v1),0,"tv3",true)<<endl;
  gDirectory->pwd();
  cout << "buf6 size "<<rr.Write("newdir/nn",&RecUtil::totv(v1),0,"tv5",true)<<endl;
  gDirectory->pwd();
  cout << "buf6 size "<<rr.Write("newdir/nn/",&RecUtil::totv(v1),0,"tv6")<<endl;
   gDirectory->pwd();
  cout << "buf7 size "<<rr.Write("newdir/nn2",&RecUtil::totv(v1),0,"tv5",true)<<endl;
  gDirectory->cd("newdir/nn2");
  cout << "buf8 size "<<rr.Write(0,&RecUtil::totv(v1),0,"tv7")<<endl;
  gDirectory->pwd();
  cout << "buf9 size "<<rr.Write("/newdir/nn/",&RecUtil::totv(v1),0,"tv7")<<endl;
  gDirectory->pwd();
  cout << "buf9 size "<<rr.Write("/",&RecUtil::totv(v1),0,"tv7")<<endl;
  gDirectory->pwd();
  return 0;
} 
