#ifndef _DbParser_h_
#define _DbParser_h_

#include <vector>
#include "DbActionDescriptor.h"
#include "RootReader.h"
#include "DbLUT.h"
#include <qdom.h>
#include <qfile.h>
#include <qstring.h>


/** \brief Database Parser
           reads template Db file and populate it
           with data from root file
           The correspondance is defined by lookup map 

              
     \author V.Zhukov,UIA   
     \version 2.0 
     \date 2002 06/2002
     \updated J.Fernandez,UniKa
     \date 01/2004
 
*/
class DbLUT;

class DbParser {

public:

DbParser(const char*  filename);
DbParser(RootReader* rec);
~DbParser();

void populate(RootReader* r);

DbActionDescriptor* getCompositeActionDescriptor() {return  compositeactiondescriptor;}
std::vector<DbActionDescriptor*> getBasicActionDescriptors() {return basicactiondescriptor;} 
bool getTree(const QString filename);
void getBasicAction(const QDomElement &a);
void getCompositeAction( QDomElement &a);
void setAttribute(QDomElement &a);
QString find(const QString& ss);
void write(const QString filename);
void write();
bool setRecord(const QString& s);
bool SetRecord(int r){record=r; return true;}
bool SetModule(int r){module=r; return true;}
DbLUT * getDBLUT() {return thedblut;}

private:

void fillresults(); 

QString templatename;

QDomDocument domTree;
std::vector<DbActionDescriptor*> basicactiondescriptor;
DbActionDescriptor* compositeactiondescriptor;

RootReader*  therecreader;
DbLUT* thedblut;
int record, module;
int ncomp;
QString idq;
};
#endif
