#ifndef DbReader_h
#define DbReader_h

#include "DbClient.h"
#include <qstring.h>

/** \brief Database and teststand measures comparison class for mdoules

              
     \author J. Fernandez, UniKa
     \version 1.0 
     \date 11/2003
 
*/

class DbReader{

public:

// Default constructor and destructor
DbReader();
~DbReader();
 
// Constructor by Module ID
DbReader(std::string modId);

// Accesors
std::string getModId();
std::string getSenId(int i);
int getNumSensors();
std::string getHybId();
std::string getDcuId(int i); // 1 = H, 2 = M, 3 = L
std::string getDecodedDcuId(); //gives DCU ID decoded from H,M,L values stored in DbReader class

// Modifiers
void setModId(std::string modId);
void setSenId(std::string senId, int i);
void setNumSensors(int num);
void setComponentsInfo(bool stat);
void setDcuInfo(bool stat);
void setHybId(std::string hybId);
void setDcuId(std::string dcuId, int i); // 1 = H, 2 = M, 3 = L

// Print components

void printComponents(void);

DbClient * getDbClient(){return theDbClient;}

private:

DbClient * theDbClient;

std::string _modId;
std::string _senId1, _senId2;
std::string _hybId;
std::string _dcuIdH, _dcuIdM, _dcuIdL;
int _numSensors;
bool componentsInfo;
bool dcuInfo;
};


#endif
