#ifndef _RecordReader_h_
#define _RecordReader_h_

#include <TFile.h> 
#include <qstring.h>
#include "daqerrormsg.h"

/** \brief Class to read localDb for the central Db XML files.

    RecordReader reads LocalDb root file
    provided by Record and extract information
    needed for the central DB 
              
     \author V.Zhukov,UIA   
     \version 2.1 
     \date  02/2003
     \updated J.Fernandez,UniKa
     \date 01/2004
 
*/

class DbLUT;
class DbForm;

class RecordReader {

  public:

RecordReader();
~RecordReader();

bool     Read(const  char* file, std::vector<int> s);
QString  Find(const QString& attr);
bool     setRecord(int i);
bool     setRecord(const QString& c);
bool     setMod(int i);
bool     setMod(const QString& c);
int      modCounter();
QString  getId() {return theid;}

 private: 
QString find( DbForm& s);
TFile* rootfile; 
DbLUT* thedblut;
TDirectory* crec;

std::vector<int> theselrec;
int theRec, theMod, nMods;
QString  theid;
};
#endif
