#include "ClientSocket.h"
#include "SocketException.h"
#include "DbClient.h"
#include <iostream>
#include <stdlib.h>
#include <sstream>
#include <qdom.h>
#include <qfile.h>
#include <qstring.h>
using namespace std;

DbClient::DbClient() {  
}

DbClient::~DbClient() {}


int DbClient::readDB(string obj_id, string s_data, string fromtable, 
			string whereselec, string and_data, string& reply){

 cout << "\t----------------------------------------------------------" <<endl;
 cout << "\t   Connecting to DB to retrieve info, please be patient" << endl;
 cout << "\t----------------------------------------------------------" <<endl;


  try {
    //    string host = "lyopc72.in2p3.fr";
    string host = "cmstrkdb.in2p3.fr";
    int port    = 3615;
    string query;
    ClientSocket client_socket(host, port);
    query  = "<?xml version=\"1.0\"?>";  
//    query += "<select db=\"test\"> ";
    query += "<select db=\"prod\"> ";
    query += s_data;
    query += " from ";
    query += fromtable;
    query += " where ";
    query += whereselec;
    query += " = ";
    query += obj_id;
    query += " ";
    query += and_data;
    query += "</select>\n\n";

    client_socket << query;
    client_socket >> reply;
//  cout << query << endl;
//  cout << reply << endl;

  }
  catch (SocketException& e) {
    cout << "Exception was caught: " << e.description() << endl;
  }          
  //  cout << "We received this response from the server:\n\"" << reply << endl;
  return reply.size();
}


int DbClient::parseReply(string replyFromDB, QStringList &columnOutput, QStringList &valueOutput){

  columnOutput.clear();
  valueOutput.clear();
  int status = 0;
  const char * replyc = replyFromDB.c_str();
  QString reply(replyc);
  QDomDocument domtree;
    if( !domtree.setContent( reply )){
    cout << "Not a valid XML file" << endl;
    return 0;
    }
    QDomElement root = domtree.documentElement();
    QDomNode n = root.firstChild();
    while ( !n.isNull() ) {
        if ( n.isElement() ) {
            QDomElement e = n.toElement();
		if(e.tagName() == "status"){
		if(!e.text().find("DBQuery: OK")){
		cout << "Bad query response" << endl;
		break;}
		else status =1;
		}
		
		else if(e.tagName() == "row"){
		QDomNode i = e.firstChild();
	        QDomElement ie;
		
    		while ( !i.isNull() ) {
	            ie = i.toElement();
			if(ie.tagName()== "column") columnOutput.push_back(ie.text());
			
			else if(ie.tagName()== "value") valueOutput.push_back(ie.text());
		i = i.nextSibling();
		}
		}

        }
        n = n.nextSibling();
    }  

return status;
}


int DbClient::giveComponentsIds(string  modId, vector<string> &compList, 
		vector<string> &idsList){
		
				
  vector<string> pList;
  pList.resize(0);

  pList.push_back("Objects contained in");
  pList.push_back(modId);
  pList.push_back("object, object_id");
  pList.push_back("object_assembly");
  pList.push_back("container_id");


  if( checkpList( pList) <=0) return 0;

  string replyFromDB;

  int replyLen = readDB(pList[1], pList[2], pList[3], pList[4], "", replyFromDB);
  if (replyLen <= 0) return 0;

  if (replyFromDB.find("row") == string::npos) {
    cout << " Object Mod ID = "<< pList[1] << " Does Not Exist in table:" <<
    pList[3] << " in Database!!!" << endl << endl;
    return 0;
  }

  QStringList columnOutput;
  QStringList valueOutput;
  if( parseReply(replyFromDB, columnOutput, valueOutput) <= 0) return 0;
  
  if (!columnOutput.size() == 0 && !valueOutput.size()==0) {

	QStringList::Iterator it2 = valueOutput.begin();  
  for (QStringList::Iterator it = columnOutput.begin(); it != columnOutput.end(); ++it ) {

	if((*it) == "OBJECT") compList.push_back((*it2).latin1());
	else if((*it) == "OBJECT_ID"){
		char *pEnd;
		idsList.push_back( (*it2).latin1());
	}
	++it2;

  }}

return idsList.size();
}  




int DbClient::giveSensorIV(string senid,std::vector<std::string> &voltage,std::vector<std::string> &current ){


  vector<string> pList;
  pList.resize(0);

  pList.push_back("IV curve for");
  pList.push_back(senid);
  pList.push_back("voltage_v, i_tot_na");
  pList.push_back("ivtest_1_sen_");
  pList.push_back("object_id");
  pList.push_back("and status = 'reference'");

  if( checkpList( pList) <=0) return 0;

  string replyFromDB;
  int replyLen = readDB(pList[1], pList[2], pList[3], pList[4], pList[5], replyFromDB);
  if (replyLen <= 0) return 0;
 
  if (replyFromDB.find("row") == string::npos) {
    cout << " Object Sen ID = "<< pList[1] << " Does Not Exist in table: " << pList[3]
    << " in Database!!!" << endl << endl;
    return 0;
  }

  QStringList columnOutput, valuesV;
  QStringList valueOutput, valuesI;
  if( parseReply(replyFromDB, columnOutput, valueOutput) <= 0) return 0;


  if (!columnOutput.size() == 0 && !valueOutput.size()==0) {

	QStringList::Iterator it2 = valueOutput.begin();  
  for (QStringList::Iterator it = columnOutput.begin(); it != columnOutput.end(); ++it ) {

	if((*it) == "VOLTAGE_V")
	valuesV = QStringList::split(" ",*it2);
	else if((*it) == "I_TOT_NA")
	valuesI = QStringList::split(" ",*it2);

	++it2;
  }


	QStringList::Iterator it3 = valuesV.begin();  
  for (QStringList::Iterator it4 = valuesI.begin(); it4 != valuesI.end(); ++it4 ) {
	voltage.push_back( (*it3).latin1() );
	current.push_back( (*it4).latin1() );
	++it3;
  }

  }

return columnOutput.size();


}


int DbClient::giveDcuId(string modId, vector<string> &dcu_id){
				
  vector<string> pList;
  pList.resize(0);

  pList.push_back("DCU Id for Mod Id");
  pList.push_back(modId);
  pList.push_back("FHIT.et_dcu_id");
  pList.push_back("object_assembly OA, fhitmeasurement_1_hyb_ FHIT");
  pList.push_back("OA.container_id");
  pList.push_back("and OA.object_id = FHIT.object_id and OA.object = 'HYB' and FHIT.status = 'reference'");

  if( checkpList( pList) <=0) return 0;

  string replyFromDB;
  int replyLen = readDB(pList[1], pList[2], pList[3], pList[4], pList[5], replyFromDB);
  if (replyLen <= 0) return 0;
 
  if (replyFromDB.find("row") == string::npos) {
    cout << " Object Mod ID = "<< pList[1] << " Does Not Exist in one of the tables: "
    << pList[3] << " in Database!!!" << endl << endl;
    return 0;
  }

  QStringList columnOutput;
  QStringList valueOutput;
  if( parseReply(replyFromDB, columnOutput, valueOutput) <= 0) return 0;
  
  if (!columnOutput.size() == 0 && !valueOutput.size()==0) {

	QStringList::Iterator it2 = valueOutput.begin();  
  for (QStringList::Iterator it = columnOutput.begin(); it != columnOutput.end(); ++it ) {
	if((*it) == "ET_DCU_ID") {

	QStringList values = QStringList::split(" ",*it2);

		for (QStringList::Iterator it3 = values.begin(); it3 != values.end(); ++it3 ) {
		dcu_id.push_back( (*it3).latin1() );}
	}
  }}

return dcu_id.size();
}  


int DbClient::giveDcuIdfromHyb(string hybId, vector<string> &dcu_id){
				
  vector<string> pList;
  pList.resize(0);

  pList.push_back("DCU Id for Hyb Id");
  pList.push_back(hybId);
  pList.push_back("et_dcu_id");
  pList.push_back("fhitmeasurement_1_hyb_");
  pList.push_back("object_id");
  pList.push_back("and status = 'reference'");

  if( checkpList( pList) <=0) return 0;

  string replyFromDB;
  int replyLen = readDB(pList[1], pList[2], pList[3], pList[4], pList[5], replyFromDB);
  if (replyLen <= 0) return 0;
 
  if (replyFromDB.find("row") == string::npos) {
    cout << " Object Hyb ID = "<< pList[1] << " Does Not Exist in table: "
    << pList[3] << " in Database!!!" << endl << endl;
    return 0;
  }

  QStringList columnOutput;
  QStringList valueOutput;
  if( parseReply(replyFromDB, columnOutput, valueOutput) <= 0) return 0;
  
  if (!columnOutput.size() == 0 && !valueOutput.size()==0) {

	QStringList::Iterator it2 = valueOutput.begin();  
  for (QStringList::Iterator it = columnOutput.begin(); it != columnOutput.end(); ++it ) {
	if((*it) == "ET_DCU_ID") {

	QStringList values = QStringList::split(" ",*it2);

		for (QStringList::Iterator it3 = values.begin(); it3 != values.end(); ++it3 ) {

		dcu_id.push_back( (*it3).latin1() );}
	}
  }}

return dcu_id.size();
}  


int DbClient::giveModType(string modId, std::string &modType){
		
  vector<string> pList;
  pList.resize(0);

  pList.push_back("Module Type for");
  pList.push_back(modId);
  pList.push_back("object, type");
  pList.push_back("object_assembly");
  pList.push_back("object_id");


  if( checkpList( pList) <=0) return 0;

  string replyFromDB;

  int replyLen = readDB(pList[1], pList[2], pList[3], pList[4], "", replyFromDB);
  if (replyLen <= 0) return 0;

  if (replyFromDB.find("row") == string::npos) {
    cout << " Object Mod ID = "<< pList[1] << " Does Not Exist in table: "
    << pList[3] << " in Database!!!" << endl << endl;
    return 0;
  }

  QStringList columnOutput;
  QStringList valueOutput;
  if( parseReply(replyFromDB, columnOutput, valueOutput) <= 0) return 0;
  
  if (!columnOutput.size() == 0 && !valueOutput.size()==0) {

	QStringList::Iterator it2 = valueOutput.begin();  
  for (QStringList::Iterator it = columnOutput.begin(); it != columnOutput.end(); ++it ) {

	if((*it) == "TYPE") modType = (*it2).latin1();
	++it2;

  }}

return modType.size();
}  



int DbClient::checkpList(vector<string> &pList){
  if (pList.size() == 0) return 0;
  cout << endl << endl << "-------------------" << endl;
  cout << "New query" << endl;
  cout << "Size = " << pList.size() << endl;
  for (int i = 0; i < pList.size(); i++) {
    cout << "Element [" << i << "] = " << pList[i] << endl;
  }
return pList.size();
}


void DbClient::printQuery(string query){

cout << query << endl;
return;
}


//  Variable check into DB
string DbClient::giveObject (string modId, string objectName, string table) //returns objectName value
{

  string answer;

  string check = "Check for ";
  check += objectName;
  
  string object = "T2.";
  object+=objectName;
  
  string where = "modulbasic_2_mod_ T2, ";
  where+= table;
  where+="_2_MOD_ T1";
  
  vector<string> pList;
  pList.resize(0);

  pList.push_back(check);
  pList.push_back(modId);
  pList.push_back(object);
  pList.push_back(where);
  pList.push_back("T1.object_id");
  pList.push_back("and T1.modulbasic_2_mod_ = T2.test_id and T1.status = 'reference'");

  if( checkpList( pList) <=0) return 0;

  string replyFromDB;
  int replyLen = readDB(pList[1], pList[2], pList[3], pList[4], pList[5], replyFromDB);

  if (replyLen <= 0) return 0;
 
  if (replyFromDB.find("row") == string::npos) {
    cout << " Object Mod ID "<< pList[1] << " Does Not Exist in table: "
    << pList[3] << " in Database!!!" << endl << endl;
    return 0;
  }

  QStringList columnOutput;
  QStringList valueOutput;
  if( parseReply(replyFromDB, columnOutput, valueOutput) <= 0) return 0;

  if (!columnOutput.size() == 0 && !valueOutput.size()==0) {

  QStringList::Iterator it2 = valueOutput.begin();  
  for (QStringList::Iterator it = columnOutput.begin(); it != columnOutput.end(); ++it ) {
	if((*it).latin1() == objectName) 
	answer = (*it2).latin1();
	it2++;
  }}


return answer;

}


// I bias values check
float DbClient::giveIbias (string senId, string objectName){ // returns I bias from sensor measurement


  float iDB;

  vector<string> pList;
  pList.resize(0);

  pList.push_back("Check for I Bias");
  pList.push_back(senId);

  pList.push_back(objectName);

  pList.push_back("ivtest_1_sen_");
  pList.push_back("object_id");
  pList.push_back("and status = 'reference'");

  if( checkpList( pList) <=0) return 0;

  string replyFromDB;
  int replyLen = readDB(pList[1], pList[2], pList[3], pList[4], pList[5], replyFromDB);

  if (replyLen <= 0) return 0;
 
  if (replyFromDB.find("row") == string::npos) {
    cout << " Object Sen ID "<< pList[1] << " Does Not Exist in table: "
    << pList[3] << " in Database!!!" << endl << endl;
    return 0;
  }

  QStringList columnOutput;
  QStringList valueOutput;
  if( parseReply(replyFromDB, columnOutput, valueOutput) <= 0) return 0;

  if (!columnOutput.size() == 0 && !valueOutput.size()==0) {

  QStringList::Iterator it2 = valueOutput.begin();  
  for (QStringList::Iterator it = columnOutput.begin(); it != columnOutput.end(); ++it ) {
	if((*it).latin1() == objectName) 
	iDB = atof((*it2).latin1());
	it2++;
  }}

cout << "Answer from DataBase:" <<endl;
cout << "Variable " << objectName <<" in table: ivtest_1_sen_" << endl;
cout << "has value " << iDB << endl << endl;


return iDB;

}

// pedestals, calibration and noise check
int DbClient::giveHist (string modId, string objectName, string table, TH1F & h){

  string check = "Check for ";
  check += objectName;
  
  string object = "T2.";
  object+=objectName;
  
  string where = "modulbasic_2_mod_ T2, ";
  where+= table;
  where+="_2_MOD_ T1";
  
  vector<string> pList;
  pList.resize(0);

  pList.push_back(check);
  pList.push_back(modId);
  pList.push_back(object);
  pList.push_back(where);
  pList.push_back("T1.object_id");
  pList.push_back("and T1.modulbasic_2_mod_ = T2.test_id and T1.status = 'reference'");

  if( checkpList( pList) <=0) return 0;

  string replyFromDB;
  int replyLen = readDB(pList[1], pList[2], pList[3], pList[4], pList[5], replyFromDB);

  if (replyLen <= 0) return 0;
 
  if (replyFromDB.find("row") == string::npos) {
    cout << " Object Mod ID "<< pList[1] << " Does Not Exist in table: "
    << pList[3] << " in Database!!!" << endl << endl;
    return 0;
  }

  QStringList columnOutput, values;
  QStringList valueOutput;
  if( parseReply(replyFromDB, columnOutput, valueOutput) <= 0) return 0;

  if (!columnOutput.size() == 0 && !valueOutput.size()==0) {

  QStringList::Iterator it2 = valueOutput.begin();  
  for (QStringList::Iterator it = columnOutput.begin(); it != columnOutput.end(); ++it ) {
	if((*it).latin1() == objectName) 
	values = QStringList::split(" ",*it2);
  }}


  vector<float> valuesDB;

  for(QStringList::Iterator it = values.begin(); it != values.end(); ++it ){
   valuesDB.push_back( atof((*it).latin1()));}


	if(valuesDB.size()!=0){
	int j=1;
	for(int i=0; i<valuesDB.size(); i++){
	h.SetBinContent(j,valuesDB[i]);
	j++;}

	}
	

return valuesDB.size();

}



string DbClient::decodeDcuId(int H, int M, int L){
char num[10];
sprintf(num,"%02X%02X%02X",H,M,L);
unsigned long dcuid = strtoul(num,NULL,16);
stringstream dcu_id;
dcu_id << dcuid << '\0';
return dcu_id.str();
}
