#include "DbLUT.h"
#include "daqerrormsg.h"
#include "SubStructureType.h"

using namespace std;

DbLUT::DbLUT() {
//  SubStructureType * sub = new SubStructureType();
//  if(SubStructureType::isColdBox()) initmapCB();
//  else initmap(); 

//	initmapCB(); 

  DT_DEBUG_LTAPPL("init DbLut");
}
/**/
DbLUT::~DbLUT() {
  thelut.clear();
}
/**/
/* the format parameter of the DbForm makes only sense for the 
   historgram type the others are not (yet) implemented
*/
void DbLUT::initmap() // for substructures
{
  thelut["SECLTMOD_val"]=DbForm("0");
  thelut["tool_id"]=DbForm("0");  // can be activated
  thelut["id"]=DbForm("SecLtSummary/TNstructid");
  thelut["status"]=DbForm("reference");
  thelut["operator"]=DbForm("Header/TNoperator");
  thelut["Tcomment"]=DbForm("0");
  thelut["Tdate"]=DbForm("Header/TNstime");	
    thelut["Nbadch"]=DbForm("Module/Summary/TInbadch");	
    thelut["Vhyb25Dcu"]=DbForm("Module/Environment/TVvhyb25Dcu");
    thelut["Vhyb125Dcu"]=DbForm("Module/Environment/TVvhyb125Dcu");  
    thelut["TempHybDcu"]=DbForm("Module/Environment/TVtemphybdcu1");
    thelut["TempHybNtsc"]=DbForm("Module/Environment/TVtemphybdcu2");
    thelut["IleakDcu"]=DbForm("Module/Environment/TVileakdcu");

    thelut["PLLDAC"]=DbForm("0");
    thelut["GAOH"]=DbForm("0");

    thelut["apvModePed"]=DbForm("Module/Summary/TIapvmped");

    thelut["pedestal"]=DbForm("Module/PeakInvOn/Pedestal/Pedestal",10);
    thelut["noise"]=DbForm("Module/PeakInvOn/Noise/CMSubtractedNoise",100);
    thelut["avcmn"]=DbForm("Module/PeakInvOn/Noise/tMean_Noise_F",1," %5.3f");
    thelut["avnoise"]=DbForm("Module/PeakInvOn/Noise/tMean_RawNoise_F",1," %5.3f");
    thelut["avped"]=DbForm("Module/PeakInvOn/Pedestal/tMean_Pedestal_F");
    thelut["badchflag"]=DbForm("Module/Summary/TIbadch");

  thelut["module_id"]=DbForm("Module/Summary/TNmodid");

// end of SECLTMOD basic action

  thelut["SECBASIC_val"]=DbForm("0");
    thelut["TempSetup"]=DbForm("Environment/TVtempbox");
    thelut["HumSetup"]=DbForm("Environment/TVhumbox");
    thelut["TempExt"]=DbForm("Environment/TVtempext");
    thelut["HumExt"]=DbForm("Environment/TVhumext");  
    thelut["Isec25"]=DbForm("0");
    thelut["Isec125"]=DbForm("0");
    thelut["Settings"]=DbForm("Header/TNsettings");
    thelut["Nsecmodules"]=DbForm("Header/TImod");
    thelut["HVbias"]=DbForm("0");
    thelut["Isecleak"]=DbForm("0");
    thelut["Nsecbadch"]=DbForm("0");
// end of SECBASIC basic action

  thelut["SECLTSUMMARY_val"]=DbForm("0");
  thelut["Run"]=DbForm("Header/TIRun");
//end of SECLTSUMMAR basic action
}

void DbLUT::initmapCB() // for modules and Cold Box
{

  thelut["MODULBASIC_val"]=DbForm("Summary/TIMODULBASIC_val");
  thelut["tool_id"]=DbForm("default");  // can be activated
  thelut["status"]=DbForm("reference");
  thelut["id"]=DbForm("Summary/TNmodid");
  thelut["Tcomment"]=DbForm("no comment");
  thelut["operator"]=DbForm("Header/TNoperator");
  thelut["StatusApv"]=DbForm("Summary/TIstatApv",1,"%3d");
  thelut["StatusPLL"]=DbForm("Summary/TIstatPll",1,"%3d");
  thelut["StatusMUX"]=DbForm("Summary/TIstatMux",1,"%3d");
  thelut["StatusDCU"]=DbForm("Summary/TIstatDcu",1,"%3d");
  thelut["StatusSensors"]=DbForm("Summary/TIstatSensor",1,"%3d");
  thelut["StatusHybrid"]=DbForm("Summary/TIstatHybrid",1,"%3d");
  thelut["DCUID"]=DbForm("Summary/TNdcuid");
  thelut["PLLDAC"]=DbForm("0");
  thelut["Settings"]=DbForm("Header/TNsettings");
    thelut["Tdate"]=DbForm("Header/TNstime");
    thelut["TempSetup"]=DbForm("Environment/TVtempbox");
    thelut["HumSetup"]=DbForm("Environment/TVhumbox");
    thelut["TempExt"]=DbForm("Environment/TVtempext");
    thelut["HumExt"]=DbForm("Environment/TVhumext");  
    thelut["TempHybDcu"]=DbForm("Environment/TVtemphybdcu1");
    thelut["TempHybNtsc"]=DbForm("Environment/TVtemphybdcu2");
    thelut["TempSenNtsc1"]=DbForm("Environment/TVtempsenntsc1");
    thelut["TempSenNtsc2"]=DbForm("Environment/TVtempsenntsc2");
    thelut["TempSenNtsc1Dcu"]=DbForm("Environment/TVtemphybdcu3");
    thelut["IleakDcu"]=DbForm("Environment/TVileakdcu");
    thelut["Ihyb25"]=DbForm("Environment/TVihyb25");
// to be fixed: ?
    thelut["Ihyb250"]=DbForm("Environment/TVihyb25");
    thelut["Ihyb125"]=DbForm("Environment/TVihyb125");
    thelut["Vhyb25"]=DbForm("Environment/TVvhyb25");
// to be fixed: ?
    thelut["Vhyb250"]=DbForm("Environment/TVvhyb25");
    thelut["Vhyb125"]=DbForm("Environment/TVvhyb125");
    thelut["Vhyb25Dcu"]=DbForm("Environment/TVvhyb25Dcu");
    thelut["Vhyb125Dcu"]=DbForm("Environment/TVvhyb125Dcu");  
    thelut["HVbias"]=DbForm("Environment/TVhvbias");
    thelut["Ileak"]=DbForm("Environment/TVileak");
    //    thelut["Itest1"]=DbForm("Summary/TVitest1");
    //thelut["Itest2"]=DbForm("Summary/TVitest2");
    //thelut["Vtest1"]=DbForm("Summary/TVvtest1");
    //thelut["Vtest2"]=DbForm("Summary/TVvtest2");
    thelut["Itest1"]=DbForm("IV/TFItest1");
    thelut["Itest2"]=DbForm("IV/TFItest2");
    thelut["Vtest1"]=DbForm("IV/TFVtest1");
    thelut["Vtest2"]=DbForm("IV/TFVtest2");
    thelut["NBadChan"]=DbForm("Summary/TInbadch");
    thelut["BadChanList"]=DbForm("Summary/TIbadchlist",0);
// new
    thelut["noisepion"]=DbForm("PeakInvOn/Noise/CMSubtractedNoise",100);
    thelut["noisepioff"]=DbForm("PeakInvOff/Noise/CMSubtractedNoise",100);
    thelut["noisedioff"]=DbForm("DecInvOff/Noise/CMSubtractedNoise",100);
    thelut["noisedion"]=DbForm("DecInvOn/Noise/CMSubtractedNoise",100);
    thelut["rawnoisepion"]=DbForm("PeakInvOn/Noise/RawNoise",100);
    thelut["rawnoisepioff"]=DbForm("PeakInvOff/Noise/RawNoise",100);
    thelut["rawnoisedioff"]=DbForm("DecInvOff/Noise/RawNoise",100);
    thelut["rawnoisedion"]=DbForm("DecInvOn/Noise/RawNoise",100);
    thelut["cmnnoisepion"]=DbForm("PeakInvOn/CommonMode/TVvavgcmn",1,"%6.3f");
    thelut["cmnnoisepioff"]=DbForm("PeakInvOff/CommonMode/TVvavgcmn",1,"%6.3f");
    thelut["cmnnoisedioff"]=DbForm("DecInvOff/CommonMode/TVvavgcmn",1,"%6.3f");
    thelut["cmnnoisedion"]=DbForm("DecInvOn/CommonMode/TVvavgcmn",1,"%6.3f");
    thelut["pedpion"]=DbForm("PeakInvOn/Pedestal/Pedestal",10);
    thelut["calPApioff"]=DbForm("PeakInvOff/PulseShape/PulseHeight",10);
    thelut["calPApion"]=DbForm("PeakInvOn/PulseShape/PulseHeight",10);
    thelut["calPAdioff"]=DbForm("DecInvOff/PulseShape/PulseHeight",10);
    thelut["calPAdion"]=DbForm("DecInvOn/PulseShape/PulseHeight",10);
    thelut["calPTpioff"]=DbForm("PeakInvOff/PulseShape/PeakTime",1);
    thelut["calPTpion"]=DbForm("PeakInvOn/PulseShape/PeakTime",1);
    thelut["calPTdioff"]=DbForm("DecInvOff/PulseShape/PeakTime",1);
    thelut["calPTdion"]=DbForm("DecInvOn/PulseShape/PeakTime",1);
    thelut["badchped"]=DbForm("Summary/TIbadchped",1);
    thelut["badchcalprof"]=DbForm("Summary/TIbadchcalprof",1);
    thelut["badchpinhole"]=DbForm("Summary/TIbadchpinhole",1);
    thelut["badchcal"]=DbForm("Summary/TIbadchcal",1);
    thelut["badchbp"]=DbForm("Summary/TIbadchbp",1);
    thelut["apvModeCal"]=DbForm("PeakInvOn/PulseShape/Mode_I");
    thelut["apvModeBP"]=DbForm("Summary/TIapvmbp",1);
    thelut["apvModePinhole"]=DbForm("Summary/TIapvmfb",1);
// in case of light test as a pinhole tests
    thelut["calA"]=DbForm("PeakInvOn/PulseShape/PulseHeight",10);
    thelut["calApinhole"]=DbForm("PeakInvOn/ForwardBias/FBiasAmp",10);
    thelut["Ipinhole"]=DbForm("PeakInvOff/Pinhole/TFIphleak",1);
    thelut["avgcmnpion"]=DbForm("PeakInvOn/CommonMode/TVavgcmn",1,"%6.3f");
    thelut["avgcmnpioff"]=DbForm("PeakInvOff/CommonMode/TVavgcmn",1,"%6.3f");
    thelut["avgcmndion"]=DbForm("DecInvOn/CommonMode/TVavgcmn",1,"%6.3f");
    thelut["avgcmndioff"]=DbForm("DecInvOff/CommonMode/TVavgcmn",1,"%6.3f");
    thelut["avgnoisepion"]=DbForm("PeakInvOn/Noise/tMean_Noise_F",1,"%6.3f");
    thelut["avgnoisepioff"]=DbForm("PeakInvOff/Noise/tMean_Noise_F",1,"%6.3f");
    thelut["avgnoisedion"]=DbForm("DecInvOn/Noise/tMean_Noise_F",1,"%6.3f");
    thelut["avgnoisedioff"]=DbForm("DecInvOff/Noise/tMean_Noise_F",1,"%6.3f");
    thelut["avgpedpion"]=DbForm("PeakInvOn/Pedestal/tMean_Pedestal_F");
    thelut["rmspedpion"]=DbForm("PeakInvOn/Pedestal/tRMS_Pedestal_F");
    thelut["avgcalPApioff"]=DbForm("PeakInvOff/PulseShape/tMean_Height_F");
    thelut["avgcalPApion"]=DbForm("PeakInvOn/PulseShape/tMean_Height_F");
    thelut["avgcalPAdioff"]=DbForm("DecInvOff/PulseShape/tMean_Height_F");
    thelut["avgcalPAdion"]=DbForm("DecInvOn/PulseShape/tMean_Height_F");
    thelut["avgcalPTpioff"]=DbForm("PeakInvOff/PulseShape/tMean_RiseTime_F");
    thelut["avgcalPTpion"]=DbForm("PeakInvOn/PulseShape/tMean_RiseTime_F");
    thelut["avgcalPTdioff"]=DbForm("DecInvOff/PulseShape/tMean_RiseTime_F");
    thelut["avgcalPTdion"]=DbForm("DecInvOn/PulseShape/tMean_RiseTime_F");
    thelut["avgcalApinhole"]=DbForm("PeakInvOn/ForwardBias/tMean_FBiasAmp_F");
    thelut["avgcalA"]=DbForm("PeakInvOn/PulseShape/tMean_Height_F");
    thelut["avgcalBP"]=DbForm("PeakInvOn/BackPlane/tMean_BPlaneAmp_F");
    thelut["calBP"]=DbForm("PeakInvOn/BackPlane/BPlaneAmp",10);
    thelut["chflag"]=DbForm("Summary/TIbadchlist",1,"%5d");

    thelut["voltageIV"]=DbForm("Summary/TVivv");
    thelut["currentIV"]=DbForm("Summary/TVivi");
    thelut["timeIt"]=DbForm("Environment/TVtimeit",1./60.,"%8.1f");
    thelut["currentIt"]=DbForm("Environment/TVit",1,"%5.0f");   

  thelut["MODULLTSUMMARY_val"]=DbForm("Summary/TIMODULLTSUMMARY_val");
  thelut["LtStatusApv"]=DbForm("Summary/TIstatApv");
  thelut["LtStatusPLL"]=DbForm("Summary/TIstatPll");
  thelut["LtStatusMUX"]=DbForm("Summary/TIstatMux");
  thelut["LtStatusDCU"]=DbForm("Summary/TIstatDcu");
  thelut["LtStatusSensors"]=DbForm("Summary/TIstatSensor");
  thelut["LtStatusHybrid"]=DbForm("Summary/TIstatHybrid");
  thelut["LtNBadChan"]=DbForm("Summary/TInbadch");
  thelut["LtBadChanList"]=DbForm("Summary/TIbadch",0);


}

void DbLUT::initmapARC() // for modules in ARC software
{

     thelut["MODULBASIC_val"]=DbForm("Summary/TIMODULBASIC_val");
     thelut["id"]=DbForm("Header/Object_C");
     thelut["Tdate"]=DbForm("Header/Date_C");
     thelut["operator"]=DbForm("Header/Operator_C");
     thelut["tool_id"]=DbForm("Header/Tool_ID_C");  
  thelut["status"]=DbForm("reference");
     thelut["Tcomment"]=DbForm("0");
  thelut["StatusApv"]=DbForm("Summary/TIstatApv",1,"%3d");
  thelut["StatusPLL"]=DbForm("Summary/TIstatPll",1,"%3d");
  thelut["StatusMUX"]=DbForm("Summary/TIstatMux",1,"%3d");
  thelut["StatusDCU"]=DbForm("Summary/TIstatDcu",1,"%3d");
  thelut["StatusSensors"]=DbForm("Summary/TIstatSensor",1,"%3d");
  thelut["StatusHybrid"]=DbForm("Summary/TIstatHybrid",1,"%3d");
  thelut["DCUID"]=DbForm("0");
  thelut["PLLDAC"]=DbForm("0");
      thelut["NBadChan"]=DbForm("Summary/TIbadchlist",-1);
      thelut["BadChanList"]=DbForm("Summary/TIbadchlist",0);
      thelut["Settings"]=DbForm("Header/Settings_C");
      thelut["TempSetup"]=DbForm("Environment/TempSetup_F");
      thelut["HumSetup"]=DbForm("Environment/HumSetup_F");
      thelut["TempExt"]=DbForm("Environment/TempExt_F");
      thelut["HumExt"]=DbForm("Environment/HumExt_F");  
      thelut["TempHybDcu"]=DbForm("Environment/TempDCU_by_DCU_I");
      thelut["TempHybNtsc"]=DbForm("Environment/TempHyb_by_DCU_I");
      thelut["TempSenNtsc1"]=DbForm("Environment/TempSenNtc1_F");
      thelut["TempSenNtsc2"]=DbForm("Environment/TempSenNtc2_F");
      thelut["TempSenNtsc1Dcu"]=DbForm("Environment/TempSenNtc1DCU_I");
      thelut["IleakDcu"]=DbForm("Environment/IleakDCU_I");
      thelut["Ihyb25"]=DbForm("Environment/Ihyb250_F",1000);
// to be fixed?:
      thelut["Ihyb250"]=DbForm("Environment/Ihyb250_F",1000);
      thelut["Ihyb125"]=DbForm("Environment/Ihyb125_F",1000);
      thelut["Vhyb25"]=DbForm("Environment/Vhyb250_F");
// to be fixed?:
      thelut["Vhyb250"]=DbForm("Environment/Vhyb250_F");
      thelut["Vhyb125"]=DbForm("Environment/Vhyb125_F");
      thelut["Vhyb25Dcu"]=DbForm("Environment/Vhyb250DCU_I");
      thelut["Vhyb125Dcu"]=DbForm("Environment/Vhyb125DCU_I");  
      thelut["HVbias"]=DbForm("Environment/HVbias_F");
      thelut["Ileak"]=DbForm("Environment/Ileak_F",1000);
      thelut["Itest1"]=DbForm("IV/TFItest1");
      thelut["Itest2"]=DbForm("IV/TFItest2");
      thelut["Vtest1"]=DbForm("IV/TFVtest1");
      thelut["Vtest2"]=DbForm("IV/TFVtest2");

      thelut["noisepion"]=DbForm("PeakInvOn/Noise/CMSubtractedNoise",100);
      thelut["noisepioff"]=DbForm("PeakInvOff/Noise/CMSubtractedNoise",100);
      thelut["noisedioff"]=DbForm("DecInvOff/Noise/CMSubtractedNoise",100);
      thelut["noisedion"]=DbForm("DecInvOn/Noise/CMSubtractedNoise",100);
      thelut["rawnoisepion"]=DbForm("PeakInvOn/Noise/RawNoise",100);
      thelut["rawnoisepioff"]=DbForm("PeakInvOff/Noise/RawNoise",100);
      thelut["rawnoisedioff"]=DbForm("DecInvOff/Noise/RawNoise",100);
      thelut["rawnoisedion"]=DbForm("DecInvOn/Noise/RawNoise",100);
     
      thelut["cmnnoisepion"]=DbForm("PeakInvOn/CommonMode/CmnNoiseChipRms",1,"%6.3f");
      thelut["cmnnoisepioff"]=DbForm("PeakInvOff/CommonMode/CmnNoiseChipRms",1,"%6.3f");
      thelut["cmnnoisedioff"]=DbForm("DecInvOff/CommonMode/CmnNoiseChipRms",1,"%6.3f");
      thelut["cmnnoisedion"]=DbForm("DecInvOn/CommonMode/CmnNoiseChipRms",1,"%6.3f");
      thelut["avgcmnpion"]=DbForm("PeakInvOn/CommonMode/TVCmnNoiseMeanRms",1,"%6.3f");
      thelut["avgcmnpioff"]=DbForm("PeakInvOff/CommonMode/TVCmnNoiseMeanRms",1,"%6.3f");
      thelut["avgcmndion"]=DbForm("DecInvOn/CommonMode/TVCmnNoiseMeanRms",1,"%6.3f");
      thelut["avgcmndioff"]=DbForm("DecInvOff/CommonMode/TVCmnNoiseMeanRms",1,"%6.3f");
      thelut["avgnoisepion"]=DbForm("PeakInvOn/Noise/tMean_Noise_F",1,"%6.3f");
      thelut["avgnoisepioff"]=DbForm("PeakInvOff/Noise/tMean_Noise_F",1,"%6.3f");
      thelut["avgnoisedion"]=DbForm("DecInvOn/Noise/tMean_Noise_F",1,"%6.3f");
      thelut["avgnoisedioff"]=DbForm("DecInvOff/Noise/tMean_Noise_F",1,"%6.3f");
      thelut["pedpion"]=DbForm("PeakInvOn/Pedestals/Pedestal",10);
      thelut["avgpedpion"]=DbForm("PeakInvOn/Pedestals/tMean_Pedestal_F");
      thelut["rmspedpion"]=DbForm("PeakInvOn/Pedestals/tRMS_Pedestal_F");
      thelut["badchped"]=DbForm("Summary/TIbadchpedestal",1);
      thelut["calPApioff"]=DbForm("PeakInvOff/PulseShape/PulseHeight",10);
      thelut["calPApion"]=DbForm("PeakInvOn/PulseShape/PulseHeight",10);
      thelut["calPAdioff"]=DbForm("DecInvOff/PulseShape/PulseHeight",10);
      thelut["calPAdion"]=DbForm("DecInvOn/PulseShape/PulseHeight",10);
      thelut["calPTpioff"]=DbForm("PeakInvOff/PulseShape/PeakTime",1);
      thelut["calPTpion"]=DbForm("PeakInvOn/PulseShape/PeakTime",1);
      thelut["calPTdioff"]=DbForm("DecInvOff/PulseShape/PeakTime",1);
      thelut["calPTdion"]=DbForm("DecInvOn/PulseShape/PeakTime",1);
      thelut["avgcalPApioff"]=DbForm("PeakInvOff/PulseShape/tMean_Height_F");
      thelut["avgcalPApion"]=DbForm("PeakInvOn/PulseShape/tMean_Height_F");
      thelut["avgcalPAdioff"]=DbForm("DecInvOff/PulseShape/tMean_Height_F");
      thelut["avgcalPAdion"]=DbForm("DecInvOn/PulseShape/tMean_Height_F");
      thelut["avgcalPTpioff"]=DbForm("PeakInvOff/PulseShape/tMean_PeakTime_F");
      thelut["avgcalPTpion"]=DbForm("PeakInvOn/PulseShape/tMean_PeakTime_F");
      thelut["avgcalPTdioff"]=DbForm("DecInvOff/PulseShape/tMean_PeakTime_F");
      thelut["avgcalPTdion"]=DbForm("DecInvOn/PulseShape/tMean_PeakTime_F");
      
  	thelut["badchcalprof"]=DbForm("Summary/TIbadchcalprof",1);
  	thelut["apvModePinhole"]=DbForm("PeakInvOff/Pinhole/Mode_I");
  	thelut["calApinhole"]=DbForm("PeakInvOff/Pinhole/Pinhole_Max",10);
  	thelut["avgcalApinhole"]=DbForm("PeakInvOff/Pinhole/tMean_PinholeMax_F");
        thelut["Ipinhole"]=DbForm("PeakInvOff/Pinhole/TFIphleak");
  	thelut["badchpinhole"]=DbForm("Summary/TIbadchpinhole",1);
  	thelut["apvModeCal"]=DbForm("PeakInvOn/PulseShape/Mode_I");
  	thelut["calA"]=DbForm("PeakInvOn/PulseShape/PulseHeight",10);
  	thelut["avgcalA"]=DbForm("PeakInvOn/PulseShape/tMean_Height_F");
  thelut["badchcal"]=DbForm("Summary/TIbadchcal",1);
  thelut["apvModeBP"]=DbForm("Summary/TIapvmbp",1);
  thelut["calBP"]=DbForm("PeakInvOn/BackPlane/BPlaneAmp",10);
  thelut["avgcalBP"]=DbForm("PeakInvOn/BackPlane/tMean_BPlaneAmp_F");
  thelut["badchbp"]=DbForm("Summary/TIbadchbp",1);
  	thelut["chflag"]=DbForm("Summary/TIbadchlist",1,"%5d");
	thelut["voltageIV"]=DbForm("IV/IV Curve Measured");
  	thelut["currentIV"]=DbForm("IV/IV Curve Measured",1000);
  thelut["timeIt"]=DbForm("Environment/TVtimeit",1./60.,"%8.1f");
  thelut["currentIt"]=DbForm("Environment/TVit",1,"%5.0f");   

}




/**/
DbForm DbLUT::find(const QString& s) {
  if(thelut.find(s)!=thelut.end()) { 
    DT_DEBUG_LTAPPL(" found "<<s<<" return "<<thelut[s].getName()); 
    return thelut[s];
  }
  else {
    DT_DEBUG_LTAPPL(" not found "<<s);  return DbForm("0");
  }
}
