#include "DbReader.h"
#include <iostream>
#include <sstream>
#include <string>
#include <qdom.h>
#include "TH1F.h"
using namespace std;

// Default constructor and destructor

DbReader::DbReader() { 
theDbClient = new DbClient(); 
}

DbReader::~DbReader() {}

// Constructor by Module ID

DbReader::DbReader(string modId){
theDbClient = new DbClient();
setModId(modId);

vector<string> compList;
vector<string> idsList;
compList.resize(0);
idsList.resize(0);
int result = theDbClient->giveComponentsIds(getModId(), compList, idsList);
if(result>0){
int j = 1;

	setComponentsInfo(true);
	for(int i=0; i<result ; i++){
	if(compList[i]=="HYB") setHybId(idsList[i]);
	else if(compList[i]=="SEN") setSenId( idsList[i], j++);
	}
	setNumSensors(idsList.size()-1);

vector<string> voltage;
vector<string> current;
for(int i=1; i <getNumSensors()+1 ; i++){
result = theDbClient->giveSensorIV(getSenId(i),voltage,current);
if(result>0) cout << "Sensor number " << i << " found." << endl;
}


vector<string> dcuList;
dcuList.resize(0);
result = theDbClient->giveDcuId(getModId(), dcuList);
if(result>0){
int k = 1;
	setDcuInfo(true);
	for(int i=0; i<result ; i++){
	setDcuId( dcuList[i], k++);
	}
}
else setDcuInfo(false);

printComponents();
}// result>0 mod_id found

else {setComponentsInfo(false);
cout << "Module ID " << modId <<  "was not found in DB" << endl << endl; }
}



// Accesors
string DbReader::getModId(){return _modId;}

string DbReader::getSenId(int i){
if(i==1) return _senId1;
else if(i==2) return _senId2;
else {cout << "Wrong index for senID. It must be 1 or 2" << endl;
	return 0;}
}

string DbReader::getDcuId(int i){
if(i==1) return _dcuIdH;
else if(i==2) return _dcuIdM;
else if(i==3) return _dcuIdL;
else {cout << "Wrong index for dcuID. It must between 1 and 3" << endl;
	return 0;}
}

string DbReader::getHybId(){return _hybId;};

// Modifiers
void DbReader::setModId(string modId){ _modId = modId;}

void DbReader::setSenId(string senId, int i){
if(i==1) _senId1=senId;
else if(i==2) _senId2=senId;
else cout << "Wrong index for senID. It must be 1 or 2" << endl;	
}

void DbReader::setHybId(string hybId){ _hybId = hybId;}

void DbReader::setDcuId(string dcuId, int i){
if(i==1) _dcuIdH = dcuId;
else if(i==2) _dcuIdM = dcuId;
else if(i==3) _dcuIdL = dcuId;
else cout << "Wrong index for dcuID. It must between 1 and 3" << endl;
}


void DbReader::setNumSensors(int num){
_numSensors = num;}

int DbReader::getNumSensors(){return _numSensors;}

void DbReader::setComponentsInfo(bool stat){
componentsInfo = stat;}

void DbReader::setDcuInfo(bool stat){
dcuInfo = stat;}

string DbReader::getDecodedDcuId(){
if(dcuInfo)
return theDbClient->decodeDcuId(atoi(getDcuId(1).c_str()),atoi(getDcuId(2).c_str()),atoi(getDcuId(3).c_str()));
else cout << "DCU Id info is not present in this DbReader" << endl;
return 0;
}



void DbReader::printComponents(void){
cout << "#########Components######" << endl;
cout << "Module Id #: " << getModId() << endl << endl;
cout << "Contains :" << endl;
cout << "Sensor Id #: " << getSenId(1) << endl;
if(getNumSensors()>1) cout << "Sensor Id #: " << getSenId(2) << endl << endl;
cout << "Hybrid Id #: " << getHybId() << endl << endl;
if(dcuInfo){
cout << "Dcu H Id #: " << getDcuId(1) << endl;
cout << "Dcu M Id #: " << getDcuId(2) << endl;
cout << "Dcu L Id #: " << getDcuId(3) << endl;
cout << "Decoded DCU ID#: "<< getDecodedDcuId() << endl;}
cout << "###########################" << endl;
}
