#include "ReadUtil.h"
#include <cstring>
#include <iostream>
#include <qtextstream.h>
#include <qtextstream.h>
/**/

int  ReadUtil::to_int(float f){
  if( f >0) return (int) (f +.5);
  else return (int) (f-.5);
}


QString ReadUtil::Root2Str(TH1F* h,DbForm dbl) { 
  if(!h) return "0";
  float m=dbl.getM();
  QString out;
   QString s;
   char f[10]="%4d ";
  
   if(! dbl.getForm().isEmpty()) {
     strncpy(f,dbl.getForm().latin1(),10);     
   }
   if( f[-2+strlen(f)] == 'd'){
     for(int i=1;i<=h->GetNbinsX();i++) {
	unsigned int kk = to_int(fabs(m*h->GetBinContent(i)));
       s.sprintf(f, kk);
       out=out.append(s); 
     }
   }
   else{
     // assume float 
     for(int i=1;i<=h->GetNbinsX();i++) {
       s.sprintf(f, m*h->GetBinContent(i));
       out=out.append(s); 
     }
   }
   return out;
}
//
QString ReadUtil::Root2Str(TProfile* pl,DbForm dbl) {
  if(!pl) return 0;
  float m=dbl.getM();
    QString out;
    QString s;
  for(int i=0;i<pl->GetNbinsX();i++) {
    s.sprintf("%5.1f %5.1f ",pl->GetBinCenter(i),m*pl->GetBinContent(i)); 
    out=out.append(s); 
  }
  return out;
   }
//
QString ReadUtil::Root2Str(TGraph* g,DbForm dbl) { 
    if(!g) return "0"; 
    float m=dbl.getM();
    QString out;
    QString s;
    double* x;
    double* y;
    int n=g->GetN();
    int is=0;
    if(n>4000) is=n-4000;
     x=g->GetX();y=g->GetY();
    for(int i=is;i<n;i++) {
      s.sprintf("%5.1f %5.1f ",x[i],m*y[i]);
      out=out.append(s);
    }
    return out;
  }
//
QString ReadUtil::Root2StrX(TGraph* g,DbForm dbl) { 
    if(!g) return "0"; 
    float m=dbl.getM();
    QString out;
    QString s;
    double* x;
    double* y;
    int n=g->GetN();
    int is=0;
    if(n>4000) is=n-4000;
     x=g->GetX();
    for(int i=is;i<n;i++) {
      s.sprintf("%5.1f ",x[i]);
      out=out.append(s);
    }
    return out;
  }
//
QString ReadUtil::Root2StrY(TGraph* g,DbForm dbl) { 
    if(!g) return "0"; 
    float m=dbl.getM();
    QString out;
    QString s;
    double* x;
    double* y;
    int n=g->GetN();
    int is=0;
    if(n>4000) is=n-4000;
	y=g->GetY();
    for(int i=is;i<n;i++) {
      s.sprintf("%5.1f ",m*y[i]);
      out=out.append(s);
    }
    return out;
  }
//
QString ReadUtil::Root2Str(TVector* v,DbForm dbl) {
  QString out;
  QString s;
  int n=v->GetNoElements();
  if(n>=1) {
    float m=dbl.getM();
    char f[10]="%6.1f";
    if(! dbl.getForm().isEmpty()) {
      strncpy(f,dbl.getForm().latin1(),10);     
    }
    int is=0;
    if(n>4000) is=n-4000;
    for(int i=is;i<n;i++) {
      float x=(*v)(i);
      // CHECK has this to be multiplied ?
      s.sprintf(f,m*x);
//	QTextOStream( &s ) << m*x << " ";
//	if(n>1) QTextOStream( &s ) << " ";
      out=out.append(s);
    }
  }
  return out;
}
//
QString ReadUtil::Root2Str(TNamed* n,DbForm dbl) {
     return n->GetTitle();
//     return n->GetName();
}
//
QString ReadUtil::Root2Str(TVectorD* v,DbForm dbl) {
  QString out;
  QString s;
  int n=v->GetNoElements();
  if(n>=1) {
    float m=dbl.getM();
    int is=0;
    if(n>4000) is=n-4000;
    for(int i=is;i<n;i++) {
      float x=(*v)(i);
      // CHECK has this to be multiplied ?
      s.sprintf("%5.1f ",m*x);
//	QTextOStream( &s ) << x;
      out=out.append(s);
    }
  }
  return out;
}
//
QString ReadUtil::Root2StrI(TVector* v,DbForm dbl) {
     QString out;
     QString s,sk;
     bool justchan =false;
     bool offch = false;
     int offchan =0;
     int n=v->GetNoElements();

   char f[10]="%4d";
  
   if(! dbl.getForm().isEmpty()) {
     strncpy(f,dbl.getForm().latin1(),10); }


     if(n>=1) {
    int is=0;
     float m=dbl.getM();
	sk=dbl.getName();
	// for BadChanList in ARCs
	if(sk=="Summary/TIbadchlist" && m==0) {justchan=true; m=1; offchan=1;}
	// for NBadChan in ARCs
	if(sk=="Summary/TIbadchlist" && m==-1) {s.sprintf("%3d",n/2); return s;}
	// for LtBadChanList in LtSummary
	if(sk=="Summary/TIbadch" && m==0) {justchan=true; m=1; offchan=1;}
	//for badch variables
	if(sk.contains("badch",TRUE)>0 && m!=0 && sk!="Summary/TInbadch"){offch =true; offchan=1;}
    if(n>4000) is=n-4000;
    for(int i=is;i<n;i++) {
      int x=int((*v)(i)); 
     if(sk.contains("_val",TRUE)>0) {QTextOStream( &s ) << ":"<<m*x << ":"; return s;}
     if(n==1 && x==0 && !(sk.contains("TIstat",TRUE)>0) && !(sk.contains("TInbadch",TRUE)>0)) return "";  // for empty tests
        // CHECK has this to be multiplied ?
	if(offch){
	if(2*((int) (i+1)/2)<i+1) s.sprintf(f,to_int(m*(x+1)));
	else s.sprintf(f,to_int(m*x));}
	else s.sprintf(f,to_int(m*x));
//	cout << " m " << m << " x " << x << endl;
//	QTextOStream( &s ) << m*x << " ";
//	if(n>1) QTextOStream( &s ) << " ";
      out=out.append(s);
      if(justchan) i++;
       }
     }
    return out;
   }
//
QString ReadUtil::Root2StrL(TVector* v,DbForm dbl) {
     QString out;
     QString s;
     int n=v->GetNoElements();
     if(n>=1) {
    int is=0;
    float m=dbl.getM();
    if(n>4000) is=n-4000;
    for(int i=is;i<n;i++) {
      int x=int((*v)(i));
      // CHECK has this to be multiplied ?
      s.sprintf(":%4d:",m*x);
      out=out.append(s);
       }
     }
    return out;
   }
