#include "DbParser.h"
#include "DbLUT.h"
#include "ReadUtil.h"
#include "daqerrormsg.h"
#include "DbForm.h"

//#include <qfile.h>
#include <vector>
#include <qstringlist.h>

 using namespace std;
 using namespace ReadUtil;

RecordReader::RecordReader()
{
 theid="0";
 thedblut=new DbLUT();
 theRec=0;
 theMod=1;
 nMods=1;
 DT_DEBUG_LTAPPL(" created recordreader ");
}
/**/

RecordReader::~RecordReader()
{delete thedblut;}

bool RecordReader::Read(const char* f, vector<int> s) {
 DT_DEBUG_LTAPPL(" read "<<f);
   theselrec=s;
   DT_DEBUG_LTAPPL(" size "<<s.size());
   if(s.size()==0) { DT_WARN(" no record selected "); return false;} 
   DT_DEBUG_LTAPPL(" s"<<s[0]<<" "<<s[1]<<" "<<s[2]<<" "<<s[3]);
   DT_DEBUG_LTAPPL(" try to open "<<f);
    rootfile=new TFile(f,"READ");
    if(rootfile->IsOpen()) { DT_DEBUG_LTAPPL(" opened "<<f); }
   DT_DEBUG_LTAPPL(" open file  "<<f);
   QString fs=f;
   QString ffs=fs.section('_',-1);
   theid=ffs.section('.',0,0);
   DT_DEBUG_LTAPPL("Id root file : "<<theid);
 return true;
}
/**/
QString RecordReader::Find(const QString& ss) {
  DbForm s=thedblut->find(ss);
  DT_DEBUG_LTAPPL(" try to find  "<<ss<<" in record "<<theRec);
  if( s.getName() == "0") return "-0";
   char dir[50];
   QString sout;
  sprintf(dir,"Record%d",theRec);
   DT_DEBUG_LTAPPL(" search  dir "<<dir);
   if(!rootfile->cd(dir)) { DT_DEBUG_DB(" not found dir "<<dir);  return "0";}
 crec=(TDirectory*)rootfile->Get(dir);
 crec->cd();
 return find(s);
}
/**/
QString RecordReader::find(DbForm& dlf)  { 
  QString slut=dlf.getName();
  DT_DEBUG_LTAPPL(" try to find "<< slut);
  QStringList slist(QStringList::split("/",slut) );
  int ndir=slist.count();
  TDirectory* dm;
  QString s;
 if(ndir==1) {dm=crec; s=slist[ndir-1];}
 if(ndir==2) {dm=(TDirectory*)crec->Get(slist[0]); 
 if(!dm) return"0"; 
 dm->cd(); s=slist[ndir-1];}

 if(ndir==3){
 TDirectory* dm1;
 if(slist[0]=="Module"){
  char str[40];
  sprintf(str,"Module%d",theMod);
	dm1=(TDirectory*)crec->Get(str);}

 else dm1=(TDirectory*)crec->Get(slist[0]);

	if(!dm1) return"0";
	dm1->cd();
		dm=(TDirectory*)dm1->Get(slist[1]); 
		if(!dm) return"0"; 
		dm->cd(); s=slist[ndir-1];}
		
 if(ndir==4){
  char str[40];
  sprintf(str,"Module%d",theMod);
	TDirectory* dm1=(TDirectory*)crec->Get(str);
	if(!dm1) return"0";
	dm1->cd();
		TDirectory* dm2=(TDirectory*)dm1->Get(slist[1]); 
		if(!dm2) return"0"; 
		dm2->cd(); 
			dm=(TDirectory*)dm2->Get(slist[2]); 
			if(!dm) return"0"; 
			dm->cd();s=slist[ndir-1];}
		 
   if(s.contains("TV", TRUE)>0) {  
     if((TVector*)dm->Get(s)!=0)  return Root2Str((TVector*)dm->Get(s),dlf);  }
  if(s.contains("_F", TRUE)>0) {  
     if((TVector*)dm->Get(s)!=0)  return Root2Str((TVector*)dm->Get(s),dlf);}
  if(s.contains("TI", TRUE)>0) {  
     if((TVector*)dm->Get(s)!=0)  return Root2StrI((TVector*)dm->Get(s),dlf);}
 if(s.contains("_I", TRUE)>0) {  
     if((TVector*)dm->Get(s)!=0)  return Root2StrI((TVector*)dm->Get(s),dlf);}
  if(s.contains("TL", TRUE)>0) {  
     if((TVector*)dm->Get(s)!=0)  return Root2StrL((TVector*)dm->Get(s),dlf);}
   if(s.contains("TH", TRUE)>0) {
     if((TH1F*)dm->Get(s)!=0)  return  Root2Str((TH1F*)dm->Get(s),dlf); }
   if(s.contains("TN", TRUE)>0) {
     if((TNamed*)dm->Get(s)!=0)  return  Root2Str((TNamed*)dm->Get(s),dlf); }
   if(s.contains("TG", TRUE )>0) {
     if((TGraph*)dm->Get(s)!=0)  return  Root2Str((TGraph*)dm->Get(s),dlf); }
   if(s.contains("TP", TRUE)>0) {
     if((TProfile *)dm->Get(s)!=0)  return  Root2Str((TProfile*)dm->Get(s),dlf); }
// else
   TH1F* h=(TH1F*)dm->Get(s); 
   if(h!=0){ QString sout=Root2Str(h,dlf);  return sout;}
 
   DT_DEBUG_LTAPPL("=====not found "<<s);
   return "0";
}
/**/
bool  RecordReader::setRecord(int i) {
  if(theselrec.size()<i+1) return false;
  theRec=theselrec[i];
}
/**/
bool  RecordReader::setRecord(const QString& s) {
  char str[40];
 for (int i=0;i<100;i++)
    {
      sprintf(str,"Record%d/Header",i);
     TDirectory*  dd=(TDirectory*)rootfile->Get(str);
      if (dd) { 
	dd->cd();
	TNamed* ncdb=(TNamed*)dd->Get("TNcdb");
	if(ncdb) {
	  if(ncdb->GetName()==s)  {
 theRec=i; nMods=modCounter(); return true;}
	} else return false;

      } 
    }

}
/**/
bool  RecordReader::setMod(int i) {
  if(nMods<i) return false;
  theMod=i;
}
/**/
bool  RecordReader::setMod(const QString& s) {
  char str[40];
 for (int i=1;i<28;i++)
    {
      sprintf(str,"Record%d/Module%d/Summary",theRec,i);
     TDirectory*  dd=(TDirectory*)rootfile->Get(str);
      if (dd) { 
	dd->cd();
	TNamed* ncdb=(TNamed*)dd->Get("TNmodid");
	if(ncdb) {
	  if(ncdb->GetName()==s)  {
 theMod=i; return true;}
	} else return false;

      } 
    }

}
/**/

int RecordReader::modCounter(){
int counter = 0;
char str[40];
 for (int i=1;i<28;i++)
 {
      sprintf(str,"Record%d/Module%d",theRec,i);
     TDirectory*  dd=(TDirectory*)rootfile->Get(str);
      if (dd) counter++;
  }

return counter;
} 
 
