#ifndef _ProcedureDescriptor_h_
#define  _ProcedureDescriptor_h_
#include <cstring>
/** 
    \brief ProcedureDescriptor  define seetings
           for the Procedure class. It is populated from
           the xml file name of which  obtained from the Db.
              
   float maxhumiditythv;
  float maxhumiditycooldown;    \author V.Zhukov.UIA  
     \version 1.0 
     \date 2001 19/09
 
*/

class ProcedureDescriptor {
private:
  char fScenariofile[80];
  char fResultsfile[80];
  char fXmlfile[80];
  char fAnalSetfile[80];
public:
  short maxacqerr;  ///< max error before module is flagged as bad
  short maxrunacqerr; ///< max daq error after  module is excluded from run 
  const char* scenariofile(){return fScenariofile;}  ///<scenario file
  int dtslowctrl;      ///< dtime for slow control
  int wait;           ///< wait
  int updatetries;     //< how many times the program waits for a new spill
  int updatewait;    /**< how long the program waits between two requests
			for a new spill
		     */
  float maxhumidityhvset; ///< maximal humidity accepted for increasing hv
  float maxhumiditycooldown;///<maximal humidity for cooling down. 
  float temperatureaccuracy;//< in which accuracy the temperature has to be reached.
  int powerswitchondelay; ///< the time before the modules are switched on
  const char* resultsfile(){return fResultsfile;};///<results file 
  const char* xmlfile(){return fXmlfile;}  ///<results file 
  const char* analsetfile() {return fAnalSetfile;}  ///<results file 
 
  void setScenarioFile(const char* infile){ 
    strcpy(fScenariofile,infile);
  }
  void setResultsFile(const char* infile){ 
    strcpy(fResultsfile,infile);
  }
  void setXmlFile(const char* infile){ 
    strcpy(fXmlfile,infile);
  }
  void setAnalSetFile(const char* infile){ 
    strcpy(fAnalSetfile,infile);
  }
};



#endif




