#ifndef SubStructureType_H
#define SubStructureType_H

#include "substructtypes.h"

/** \brief indicated  the substructure type for the test

    At the start of the program the program has to fill 
    the static member with the correct sub structure.
    Other programs can use it to determine stucture specific 
    actions. 

    \author W.Beaumont UA 
    \20040203 
    \version 1.0 
*/

class SubStructureType {

   public :
    
  /** constructor for call without changing the structure type
  */
  SubStructureType(){}
  /** constructor for changing the structure type 
      the stuctype should be one of the known types
      for the function strtosubstruct in the substructuretype.h 
  */
  SubStructureType( std::string structtype ) {
    theStructType=lttest::strtosubstruct(structtype);
  }
  
  /** constructor for changing the substructure type */
  SubStructureType( lttest::substructtypes structtype ) {
    theStructType=structtype;
  }
  
  /** returns true of the stucture type is a not a cold box 
      and not undefined 
  */
  static bool isNotColdBox(){ 
    return (theStructType > lttest::COLDBOX);
  }

  /** returns true if the structure type is a cold box 
      returns false if it is no a valid structure or not a coldbox
  */
  static bool isColdBox(){ 
    return (theStructType == lttest::COLDBOX);
  }
  /** returns true if the structure is defined 
      coldbox or sub structure
  */
  static bool isValidStructure(){
    return ( theStructType != lttest::UNKNOWNSTRUCT);
  }

  static lttest::substructtypes getStructType(){ return theStructType;}
private :
  static lttest::substructtypes theStructType;
 
};



#endif 
