#ifndef DCUINFO
#define DCUINFO
/** basic info of the DCU 
 */
class DcuInfo {
  friend class DcuInfoParser;
 public:
  /**
     Dcu 
   */
  DcuInfo(){initDcuCalValues();}
  /** 
      @param id the hardwired id . 
   */
  DcuInfo(unsigned int id) { 
    initDcuCalValues();
    // fDcuId from dcuinfo.h 
    fDcuId=id;
  }
 DcuInfo(unsigned int id,float gain=0,
	 unsigned short tempoffset=0,
	 float reftemp=-300) { 
   if( tempoffset) {  fTempRefValue=tempoffset;}
   if(reftemp >-300) {fRefTemp=reftemp;}
   if(gain){ fAdcGain=gain;}
   fDcuId=id;
 }
 float getDcuAdcGain(){ return fAdcGain;}
 float getRefTemperature(){ return fRefTemp;}
 unsigned int getTempertureOffset() { return fTempRefValue;}
 unsigned int getDcuId(){ return fDcuId;}

// default settings in case the default values are not precise enough
  void setDcuCalValues( float gain,unsigned short tempoffset,
		       float temp=-300){
    fAdcGain=gain;  fTempRefValue=tempoffset;
    if(temp > 300) {fRefTemp=temp;}
  }
   protected :
    void setDcuId(unsigned int id) {  fDcuId=id; }
  
    
   unsigned int fDcuId;
  float fAdcGain;
  unsigned short fTempRefValue;
  float fRefTemp;

 private:
 void   initDcuCalValues(){
    fDcuId=0;
    fAdcGain=2218;
    fRefTemp=25;
    fTempRefValue=2469; // estimate @ 25 C
  }
};

#endif
