#ifndef MODULEINFO
#define MODULEINFO

#include "ModId.h"
#include "positioninfo.h" 
//#include <iostream> 

class ModuleInfoParser;
class OptoHybridInfo;
class ModuleInfoDisplayExch;

class ModuleInfo: public ModId {
  friend class ModuleInfoParser;
  friend class ModuleMenuImpl;
  friend class ModuleInfoDisplayExch;
 public: 
  // needs a PositionInfo by ref !! 
  ModuleInfo(PositionInfo* pi){ 
    CommonClassInit(pi);
  }
  /** dummy ModuleInfo only need for ModId filled in */
  ModuleInfo(PositionInfo* pi,ModId* mi):ModId(*mi){ 
    CommonClassInit(pi);
  }
  ~ModuleInfo(){};
  //int geModtFollownr(){return fModPi->getFollownr();}
  //int getRing(){return fModPi->fRing;}
  //int getRingPos(){ return fModPi->fRingPos;}
  int getDelayOffset25ns(){return fDelayOffset25ns;}
  int getDelayOffsetFine(){return fDelayOffsetFine;}
  int getHvConnector(){ return fHvConnector;}
  int getHvCircuit(){ return fHvCircuitNr;}

 protected: 
  PositionInfo* fModPi;
  int fHvConnector;
  int fHvCircuitNr;
  int fSiTConnector;
  int fSiTCircuitNr; 
  int fDelayOffset25ns;
  int fDelayOffsetFine;
  int fDelayCorrection;

 private:
  void CommonClassInit(PositionInfo* pi){
      fModPi=pi;
    fHvConnector=-1;fHvCircuitNr=1; fSiTConnector=-1;fSiTCircuitNr=-1;
    fHvCircuitNr=-1;
  }
  
};

#endif
