#ifndef STRUCTCONINFO
#define STRUCTCONINFO
#include "pmap.h"

class StructConInfo {
  friend class StructConParser;
 public:
  struct circuitinfo{
    int fFedChan;
    int fFedSerialNr;
    int fMuxDevice;
    int fMuxCard;
    int fMuxChannel;
  } ;

  struct hvcircuitinfo{
    int fHvDevice;
    int fBiasDevice;
  } ;


  StructConInfo(){}
  ~StructConInfo(){}

  circuitinfo* getCircuitInfo(int connr,int cirnr){
    pmap<int,circuitinfo*>* connector=fConnectors.getP(connr);
    if(! connector) {return 0;}
    return connector->getP(cirnr);
  }   
  
   hvcircuitinfo* getHvCircuitInfo(int connr,int cirnr){
    pmap<int,hvcircuitinfo*>* connector=fHvConnectors.getP(connr);
    if(! connector) {return 0;}
    return connector->getP(cirnr);
  }  
 
 protected:
  void clear(){
    for ( pmap<int,pmap<int,circuitinfo*>*>::iterator it=fConnectors.begin();
	  it !=fConnectors.end();it++) {
      (it->second)->clearpointermap();     
    }
    fConnectors.clearpointermap();
    for ( pmap<int,pmap<int,hvcircuitinfo*>*>::iterator it=fHvConnectors.begin();
	  it !=fHvConnectors.end();it++) {
      (it->second)->clearpointermap();     
    }
    fHvConnectors.clearpointermap();
  }
      
  pmap<int,pmap<int,circuitinfo*>*> fConnectors;
  pmap<int,pmap<int,hvcircuitinfo*>*> fHvConnectors;
    
};



#endif
