#ifndef STRUCTUREINFO
#define STRUCTUREINFO
#include <string>
#include "pmap.h"
// include is here needed to access the delete functions of OptoModInfo
#include "ccuinfo.h"
#include "optomodinfo.h" 
 
class StructureInfo {
  friend class StructureParser;
 public:
  StructureInfo(){fBenchPos=-1; }
  ~StructureInfo(){
    modules.clearpointermap( );
    fCcus.clearpointermap( );
  }

  std::string getStructureId(){ return fId;}
  std::string getStructureType(){ return fType;}
  // get the ccuadddr
  int getCcuAddr( int ccunr){
    if( fCcus.find(ccunr) == fCcus.end()) { return -1;}
    else { return fCcus[ccunr]->getCcuAddr() ;}
  }
  // get the full CCU information
  CcuInfo* getCcuInfo( int ccunr) {
    if( fCcus.find(ccunr) == fCcus.end()) { return 0;}
    else { return fCcus[ccunr] ;}
  }
   
  pmap <int, OptoModInfo*>* getOptoModInfo() {
    return &modules;
  }
  int getNrCcus(){ return fCcus.size();} 
  int getNrOptoMods(){ return modules.size();}
  /** returns the pointer to the module with follownr i
      if not found it returns 0 
  */
  OptoModInfo*  getOptoModInfo(int i){ return modules.getP(i);}
 /** returns the pointer to the module with is stored at position i
     in the optomodule map  else it  returns 0 
     Take care the position is not a fixed value.
     So on different positions in the program it can return 
     different results is there are modules added or removed. 
     This methode can be used to go trough the list of all modules.
     
 */
  OptoModInfo*  getOptoModInfoNr(int i) {return modules. getPnr(i);}

  /** returns the first module in the map and also set the 
      actual pointer in pmap to the first pointer 
  */
  OptoModInfo* getFirsOptoModInfo() { return modules.getFirstP(); }
  
  /** returns the pointer to the next optomod info in the structure
      see pmap theNextP
  */
      
  OptoModInfo* getNextOptModInfo() {return modules.getNextP();}


  int getBenchPosition(){return fBenchPos;}
  void setBenchPosition(int i ){ fBenchPos=i;}
  
  protected :
/// fills the information of the Ccu's into the module info
  void setOptoModCcuAddr(){
    for(pmap <int, OptoModInfo*>::const_iterator iter=modules.begin();
	iter != modules.end(); iter++) {
      int ccuaddr=getCcuAddr(iter->second->getCcuNr());
      iter->second->setCcuAddr(ccuaddr);
    }
  }
  std::string fId;
  std::string fType;
  pmap<int,CcuInfo*> fCcus;
  pmap <int, OptoModInfo*> modules;
  int fBenchPos; 
};

#endif
