#include "DefaultPath.h"

#ifdef LTSTRUCT
#define DEFPATHS "STRUCTHOME"
#else
#define DEFPATHS "DEFANAHOME"
#endif


static std::string LtGenDefaultPath( std::string& defaultpath, std::string defdir, 
				     std::string instr, bool init ) {
   if( instr.size() && ! init  ) { 
     if( instr[0]=='/' ){ 
       defaultpath=instr;
     }
     else {
       // assume dir from home directory 
       std::string homepath=getenv("HOME") ;
       defaultpath=homepath+"/"+instr;
     }
   }
   if( (!defaultpath.size()) || init ){
     if(getenv(DEFPATHS)) {
       defaultpath=getenv(DEFPATHS);
	defaultpath=defaultpath+ "/"+ defdir+"/";
     } 
     else { 
       defaultpath="/tmp/";
       defaultpath=defaultpath+defdir+"/";
     }
   }
   // else return defaultpath 
   return defaultpath; 
}

std::string lttest::DefaultStuctureInfoPath(std::string instr, bool init) {
  static std::string defaultpath;
  return LtGenDefaultPath(defaultpath,"data",instr,init);
}


std::string lttest::DefaultDataPath(std::string instr, bool init ) {
  static std::string defaultpath;
  return LtGenDefaultPath(defaultpath,"data",instr,init);
}


std::string lttest::DefaultExecPath(std::string instr, bool init) {
   static std::string defaultpath;
   return LtGenDefaultPath(defaultpath,"exe",instr,init);
}

std::string lttest::DefaultConfigPath(std::string instr, bool init) {
  static std::string defaultpath;
  return LtGenDefaultPath(defaultpath,"config",instr,init); 
}

std::string lttest::DefaultStructHomePath(std::string instr, bool init) {
  static std::string defaultpath;
  return LtGenDefaultPath(defaultpath,"/",instr,init);
}

std::string lttest::DefaultScenarioFilePath(std::string instr, bool init) {
  static std::string defaultpath;
  return LtGenDefaultPath(defaultpath,"config",instr,init);
}

std::string lttest::DefaultLogFilePath(std::string instr, bool init) {
  static std::string defaultpath;
  return LtGenDefaultPath(defaultpath,"data",instr,init);
}

std::string lttest::FullPathFilename(std::string filename,std::string pathname){
  std::string retpath; retpath.resize(0);
  if( filename.size() && pathname.size()) {
    if ( filename[0]== '/' ) {
      retpath=filename;
    }
    else {
      unsigned int pathlength=pathname.size();
      if ( pathname[pathlength-1] != '/' ) {
	pathname+='/';
      }
      retpath=pathname+filename;
    }
  }
  return retpath;
}

std::string lttest::StripCvsSubsitution( const std::string cvssubstr) {
  std::string cvssub(cvssubstr);
   unsigned int pos=cvssub.find_first_of(' ');
  if( pos <  cvssub.size()) {
    cvssub.erase(0,pos+1);
    pos=cvssub.find_last_of('$');
    if( pos < cvssub.size()) {
      cvssub.erase(pos-1, cvssub.size()-1);
    }
  }
  return cvssub;
}

std::string lttest::projectversionnumber="not defined";


